searchData={"items":[{"type":"task","title":"mix altworx.scenario_release","doc":"Assembles an Altworx scenario release for the current project. It is done in\na docker container based on an image which ensures correct erlang and Elixir\nversions, so they are compatible with Altworx.\n\n    $ mix altworx.scenario_release","ref":"Mix.Tasks.Altworx.ScenarioRelease.html"},{"type":"module","title":"Runbox.Scenario.Config","doc":"Provides configuration to a scenario.","ref":"Runbox.Scenario.Config.html"},{"type":"function","title":"Runbox.Scenario.Config.read_file/2","doc":"Read file from the config dir.\n\nThe file is located in the configuration directory, in a folder matching the `scenario_id` param.\nThe file is read if it exists and content is returned as `{:ok, content}`, otherwise `{:error,\nreason}` is returned.","ref":"Runbox.Scenario.Config.html#read_file/2"},{"type":"function","title":"Runbox.Scenario.Config.resolve_file/2","doc":"Resolves a path to a file in scenario config.\n\nThe file is located in the configuration directory, in a folder matching the `scenario_id` param.\nThis function resolves the path so that it can be used with `File` functions directly.  The\nexistence of the file is not verified. Note if you want to just read the file, you can use\n`read_file/2`, this function should be used when you need to handle the file in a special manner\n(e.g. streaming).","ref":"Runbox.Scenario.Config.html#resolve_file/2"},{"type":"module","title":"Runbox.Scenario.Helper","doc":"Support for helper processes for scenarios.\n\nProvides a supervisor and process registry under which scenarios can start\ntheir side-kick processes intended for housekeeping tasks.","ref":"Runbox.Scenario.Helper.html"},{"type":"function","title":"Runbox.Scenario.Helper.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Runbox.Scenario.Helper.html#child_spec/1"},{"type":"function","title":"Runbox.Scenario.Helper.start_link/1","doc":"Starts a supervisor with dynamic supervisor and process registry.","ref":"Runbox.Scenario.Helper.html#start_link/1"},{"type":"function","title":"Runbox.Scenario.Helper.via_registry/1","doc":"Returns a `:via` name to be used in the helper process registry.","ref":"Runbox.Scenario.Helper.html#via_registry/1"},{"type":"function","title":"Runbox.Scenario.Helper.with_helper/3","doc":"Executes a given `callback` over running helper.\n\nChecks whether the helper with `name` registered under helper registry is\nalready running. If not, then it starts the process according to `child_spec`\nunder the dynamic supervisor. In either case, it passes the helper process\npid to the `callback`.\n\nIt is the responsibility of the helper process to register its name with the\nhelper registry via the `via_registry/1`.","ref":"Runbox.Scenario.Helper.html#with_helper/3"},{"type":"function","title":"Examples - Runbox.Scenario.Helper.with_helper/3","doc":"iex> child_spec = %{\n    ...>   id: MyHelper,\n    ...>   start: {\n    ...>     Agent,\n    ...>     :start_link,\n    ...>     [fn -> 1 end, [name: Helper.via_registry(MyHelper)]]\n    ...>   }\n    ...> }\n    iex> :ok = Helper.with_helper(MyHelper, child_spec, fn pid -> Agent.update(pid, & &1 + 1) end)\n    iex> Helper.with_helper(MyHelper, child_spec, fn pid -> Agent.get(pid, & &1) end)\n    2","ref":"Runbox.Scenario.Helper.html#with_helper/3-examples"},{"type":"behaviour","title":"Runbox.Scenario.Manifest","doc":"Behaviour and struct for scenario manifest.","ref":"Runbox.Scenario.Manifest.html"},{"type":"callback","title":"Runbox.Scenario.Manifest.get_info/0","doc":"Invoked to obtain the scenario manifest.","ref":"Runbox.Scenario.Manifest.html#c:get_info/0"},{"type":"callback","title":"Runbox.Scenario.Manifest.on_start/0","doc":"Invoked once when the scenario run starts.\n\nUseful for doing any necessary preparations for scenario run.\n\n**Warning:** Do not rely on any external resources (e.g. SQL queries) which may\nchange the scenario logic.\n\nThis callback is optional. If it is not implemented, no action is performed\nwhen starting the scenario run.","ref":"Runbox.Scenario.Manifest.html#c:on_start/0"},{"type":"type","title":"Runbox.Scenario.Manifest.attribute_detail/0","doc":"Assets group attributes metadata.\n\nMetadata helps the UI to render form for the group attributes definition.\nAttributes of the group are saved in asset attributes in Reality Network\nif group is materialized as asset in Reality Network.","ref":"Runbox.Scenario.Manifest.html#t:attribute_detail/0"},{"type":"type","title":"Properties - Runbox.Scenario.Manifest.attribute_detail/0","doc":"* `:name` - user-friendly attribute name - what is set.\n  * `:description` - longer attribute description - what the attribute does, the unit, ...\n  * `:path` - path to attribute in attributes JSON.\n  * `:type` - type of attribute value (helps the UI to render form input).","ref":"Runbox.Scenario.Manifest.html#t:attribute_detail/0-properties"},{"type":"type","title":"Runbox.Scenario.Manifest.group_of_assets/0","doc":"Metadata (template) of assets group.\n\nThe scenario should be able to carry a list of groups it uses. These groups\ncan then be easily created in the UI by the user without having to fill in\nsome information manually. Metadata defines these helpers for the UI.","ref":"Runbox.Scenario.Manifest.html#t:group_of_assets/0"},{"type":"type","title":"Properties - Runbox.Scenario.Manifest.group_of_assets/0","doc":"* `:name` - short name of group template for UI.\n  * `:description` - description of assets group.\n  * `:asset_type` - asset type of asset created by the group.\n  * `:edge_type` - edge type for connecting assets in the group.\n  * `:edge_direction` - edge direction (true = from group asset to assets in group).\n  * `:attributes` - description of group attributes.","ref":"Runbox.Scenario.Manifest.html#t:group_of_assets/0-properties"},{"type":"type","title":"Runbox.Scenario.Manifest.notification_metadata/0","doc":"Notification specification metadata.","ref":"Runbox.Scenario.Manifest.html#t:notification_metadata/0"},{"type":"type","title":"Properties - Runbox.Scenario.Manifest.notification_metadata/0","doc":"* `:name` - user-friendly name for the notification type\n  * `:metadata_types` - describes metadata the notification caries, this information can be used for\n    additional filtering in subscriptions. It can be empty map if no metadata is needed.\n  * `type_name` - is a binary specifying the name of the notification metadata type\n  * `:type` - type of notification metadata, can be either a `:number`, `:string` or `:boolean`.","ref":"Runbox.Scenario.Manifest.html#t:notification_metadata/0-properties"},{"type":"type","title":"Runbox.Scenario.Manifest.notification_type/0","doc":"Notification type is an atom uniquely identifying the notification in the scenario","ref":"Runbox.Scenario.Manifest.html#t:notification_type/0"},{"type":"type","title":"Runbox.Scenario.Manifest.t/0","doc":"","ref":"Runbox.Scenario.Manifest.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.Manifest.Incident","doc":"Struct representing incident manifest","ref":"Runbox.Scenario.Manifest.Incident.html"},{"type":"type","title":"Runbox.Scenario.Manifest.Incident.t/0","doc":"","ref":"Runbox.Scenario.Manifest.Incident.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.Manifest.IncidentFrame","doc":"Struct representing one column in incident forecast UI widget.","ref":"Runbox.Scenario.Manifest.IncidentFrame.html"},{"type":"module","title":"Properties: - Runbox.Scenario.Manifest.IncidentFrame","doc":"* `:name` displayed column name\n  * `:since` time frame start interval in ms\n  * `:till` time frame end interval in ms","ref":"Runbox.Scenario.Manifest.IncidentFrame.html#module-properties"},{"type":"type","title":"Runbox.Scenario.Manifest.IncidentFrame.t/0","doc":"","ref":"Runbox.Scenario.Manifest.IncidentFrame.html#t:t/0"},{"type":"behaviour","title":"Runbox.Scenario.Template.StageBased","doc":"Module defines behaviour used in scenarios as template.\n\nScenario template implementations are main components of scenario. Runtime uses callbacks of\nthis behaviour to start scenario in run and to handle incoming messages. Each template\nbehaviour implementation is represented as separate process in runtime called `TemplateCarrier`.\n\nTemplate is intended to be used to model behaviour of assets of single type per template.\nIndividual asset states are represented as `t:Toolbox.Runtime.Stage.Unit.t/0`. Initial assets are\ndefined via `c:Runbox.Scenario.Template.StageBased.instances/0` callback. This callback should\nreturn list of unit definitions (`t:Runbox.Scenario.Template.StageBased.instances_def/0`).\n\nTemplates are linked together via subscriptions provided by callback\n`c:Runbox.Scenario.Template.StageBased.subscriptions/0`. Subscription is defined as tuple\ncontaining component definition and routing rule list. It is possible to subscribe to other\ntemplates, input and load topics. Routing rules are used to locate units when message is handled.\nWhen routing rule succeeds, callback `c:Runbox.Scenario.Template.StageBased.handle_message/2`\nis called, when routing rule fails to locat existing unit,\n`c:Runbox.Scenario.Template.StageBased.handle_asset_discovery/1` gets called instead.\n\nUnit initialization can produce side effects via `c:Runbox.Scenario.Template.StageBased.init/2`\ncallback. This callback is triggered when instances are produced by\n`c:Runbox.Scenario.Template.StageBased.instances/0` or\n`c:Runbox.Scenario.Template.StageBased.handle_asset_discovery/1` callbacks. Units are already\nregistered in the time when this callback is triggered, so changes in unit attributes won't\nchange unit registration (defined by `c:Runbox.Scenario.Template.StageBased.subscriptions/0`).\n\nWhen message from subscribed publisher is handled by the `TemplateCarrier`, runtime tries to\nlocate asset unit using given subscription configuration. If there is such a unit, runtime\ncalls `c:Runbox.Scenario.Template.StageBased.handle_message/2` callback and uses message and\nlocated message as attributes. In case that no unit was found,\n`c:Runbox.Scenario.Template.StageBased.handle_asset_discovery/1` gets called instead.","ref":"Runbox.Scenario.Template.StageBased.html"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.handle_asset_discovery/1","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:handle_asset_discovery/1"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.handle_asset_discovery/2","doc":"Invokes `template_module.asset_discovery` with given `message`.","ref":"Runbox.Scenario.Template.StageBased.html#handle_asset_discovery/2"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.handle_message/2","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:handle_message/2"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.handle_message/3","doc":"Invokes `template_module.handle_message` with given `message` and `unit`.","ref":"Runbox.Scenario.Template.StageBased.html#handle_message/3"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.init/2","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:init/2"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.init/3","doc":"Updates unit and sets initial unit state.","ref":"Runbox.Scenario.Template.StageBased.html#init/3"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.instances/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:instances/0"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.instances/1","doc":"Returns list of of asset units.","ref":"Runbox.Scenario.Template.StageBased.html#instances/1"},{"type":"callback","title":"Runbox.Scenario.Template.StageBased.subscriptions/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#c:subscriptions/0"},{"type":"function","title":"Runbox.Scenario.Template.StageBased.subscriptions/1","doc":"Returns subscriptions defined in `template_module`.","ref":"Runbox.Scenario.Template.StageBased.html#subscriptions/1"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.handle_asset_discovery_resp/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:handle_asset_discovery_resp/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.handle_message_resp/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:handle_message_resp/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.instances_def/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:instances_def/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.routing_key_definition/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:routing_key_definition/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.subscription_def/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:subscription_def/0"},{"type":"type","title":"Runbox.Scenario.Template.StageBased.template_output/0","doc":"","ref":"Runbox.Scenario.Template.StageBased.html#t:template_output/0"},{"type":"module","title":"Runbox.Scenario.Type","doc":"Defines supported scenario types.\n\nYou can use this in Manifest instead of hard-coding the particular value.\n\n```\n%Runbox.Scenario.Manifest{\n  type: Runbox.Scenario.Type.stage(),\n  ...\n}\n```","ref":"Runbox.Scenario.Type.html"},{"type":"function","title":"Runbox.Scenario.Type.stage/0","doc":"Type for GenStage-based scenario runtime.","ref":"Runbox.Scenario.Type.html#stage/0"},{"type":"type","title":"Runbox.Scenario.Type.t/0","doc":"","ref":"Runbox.Scenario.Type.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.UIAction","doc":"Definition of action to be fired from UI.\n\nIn scenario list of `Runbox.Scenario.UIAction`s is defined and stored in asset\nmap entity. When action is fired from UI, scenario receives `Toolbox.Scenario.UserAction`.","ref":"Runbox.Scenario.UIAction.html"},{"type":"function","title":"Runbox.Scenario.UIAction.actions/1","doc":"Converts list of UI actions to actions property.\n\nMap in resulting list contains two properties:\n  * `action` - action (`topic`, `type`, `details`) encoded to JWT.\n  * `meta` - metadata (`name`, `description`) to be used in UI.\n\nResulting list of maps should be stored to some entity in asset map.","ref":"Runbox.Scenario.UIAction.html#actions/1"},{"type":"type","title":"Runbox.Scenario.UIAction.t/0","doc":"UI action definition.\n\nProperties `topic`, `type` and `details` are serialized to JWT token and used for\nrouting of fired action. Property `topic` is name of raw topic where fired actions\nare pushed, property `type` is type to be used in `Toolbox.Message` as `type` and\nproperty `details` is stored in resulting message `body` as `details` property.\nProperties `name` and `description` are only metadata for UI.","ref":"Runbox.Scenario.UIAction.html#t:t/0"},{"type":"module","title":"Toolbox.Runtime.Stage.Unit","doc":"Struct representing a unit.","ref":"Toolbox.Runtime.Stage.Unit.html"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.attributes/1","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#attributes/1"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.id/1","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#id/1"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.new/3","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#new/3"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.set_state/2","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#set_state/2"},{"type":"function","title":"Toolbox.Runtime.Stage.Unit.state/1","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#state/1"},{"type":"type","title":"Toolbox.Runtime.Stage.Unit.t/0","doc":"","ref":"Toolbox.Runtime.Stage.Unit.html#t:t/0"},{"type":"task","title":"mix altworx.scenario_release_internal","doc":"Assembles an Altworx scenario release for the current project.\n\nThis task is to be called internally by `Mix.Tasks.Altworx.ScenarioRelease` from inside Docker.\n\n    $ MIX_ENV=prod mix altworx.scenario_release_internal","ref":"Mix.Tasks.Altworx.ScenarioReleaseInternal.html"},{"type":"task","title":"Command line options - mix altworx.scenario_release_internal","doc":"* `--force` - forces recompilation\n  * `--no-archives-check` - does not check archive\n  * `--no-deps-check` - does not check dependencies\n  * `--no-elixir-version-check` - does not check Elixir version\n  * `--no-compile` - does not compile before assembling the release\n  * `--overwrite` - if there is an existing release version, overwrite it\n  * `--path` - the path of the release\n  * `--quiet` - does not write progress to the standard output\n  * `--version` - the version of the release","ref":"Mix.Tasks.Altworx.ScenarioReleaseInternal.html#module-command-line-options"},{"type":"module","title":"Runbox","doc":"Runbox allows working with scenario releases. It can load scenario releases\nand provide information about the individual scenarios within them.","ref":"Runbox.html"},{"type":"function","title":"Runbox.generate_state_for_run_component/2","doc":"Generates initial state for run component on run slave node.\n\nBecause function should be called from code implementing scenario type (for example stage based),\nreturned value is also specific for scenario type.","ref":"Runbox.html#generate_state_for_run_component/2"},{"type":"function","title":"Runbox.get_release_scenarios/1","doc":"Retrieves information about scenarios in a release.","ref":"Runbox.html#get_release_scenarios/1"},{"type":"function","title":"Runbox.list_scenario_notification_channels/4","doc":"Lists all channels with templates defined for scenario, notification type and template type.","ref":"Runbox.html#list_scenario_notification_channels/4"},{"type":"function","title":"Runbox.list_scenario_notification_languages/5","doc":"Lists all template languages defined for scenario, notification type, template type and channel.","ref":"Runbox.html#list_scenario_notification_languages/5"},{"type":"function","title":"Runbox.list_scenario_notification_template_types/3","doc":"Lists all template types of the specified notification.","ref":"Runbox.html#list_scenario_notification_template_types/3"},{"type":"function","title":"Runbox.list_scenario_notification_types/2","doc":"Lists all notification types for a scenario.","ref":"Runbox.html#list_scenario_notification_types/2"},{"type":"function","title":"Runbox.load_and_eval_scenario_notification_templates/8","doc":"Loads and evaluates templates specified by scenario, notification type, template type, channel\nand language.\n\nIf language is not defined or does not exist, `fallback_language` is used.","ref":"Runbox.html#load_and_eval_scenario_notification_templates/8"},{"type":"function","title":"Runbox.run_on_start/2","doc":"Runs `on_start` function of scenario on run slave node.","ref":"Runbox.html#run_on_start/2"},{"type":"function","title":"Runbox.save_entity/3","doc":"Saves entity state to state store running on run master node.\n\nThis call is called from slave to master.","ref":"Runbox.html#save_entity/3"},{"type":"function","title":"Runbox.start_link_run_environment/2","doc":"Starts new environment for run.\n\nEvery run runs on own slave node. Caller process is linked with supervisor started during\nthis call. Started supervisor will supervise all run components running on slave node.","ref":"Runbox.html#start_link_run_environment/2"},{"type":"function","title":"Runbox.start_release_node/2","doc":"Starts slave node for release in `release_dir`.\n\nIf `app_env` is set, configured applications env variables are set on slave node\n(for example `ui_url` variable is needed to be set in `runbox` application env if\nnode is used for notifications evaluation, i.e. `app_env` must be set to\n`[runbox: [ui_url: \"https://some_url\"]]`).","ref":"Runbox.html#start_release_node/2"},{"type":"function","title":"Runbox.start_run_component/3","doc":"Starts scenario component on slave node.","ref":"Runbox.html#start_run_component/3"},{"type":"module","title":"Runbox.Deduplicator","doc":"Decide if a message is a duplicate by comparing it to messages already seen.\n\nOnly messages with the biggest timestamp are remembered as \"seen\". If the\nactual message has lower timestamp than the messages in \"seen\", it is\nconsidered \"old\". If it has the exact same timestamp, it is compared for\nequality with all the \"seen\" messages and if it matches, it is considered\n\"duplicate\". In any other case, the message is considered \"new\".","ref":"Runbox.Deduplicator.html"},{"type":"function","title":"Runbox.Deduplicator.deduplicate/2","doc":"Decides if a given message is a duplicate or not.\n\nReturns a tuple with `{msg_condition, deduplicator_state}` where `msg_condition` can be one of:\n\n  * `:new` - message is new and was not yet seen.\n\n  * `:old` - message is older than the messages already seen.\n\n  * `:duplicate` - message is equal to one of the latest messages already seen.","ref":"Runbox.Deduplicator.html#deduplicate/2"},{"type":"function","title":"Runbox.Deduplicator.new/2","doc":"Initializes a deduplicator.\n\n`stream` is an enumerable (possibly empty), which contains messages with\ndescending timestamps - from newest to oldest. It is used to initialize\n\"seen\" messages from messages which were already processed.\n\n`extract_timestamp` is a function which returns a timestamp for a given\nmessage.","ref":"Runbox.Deduplicator.html#new/2"},{"type":"opaque","title":"Runbox.Deduplicator.t/0","doc":"","ref":"Runbox.Deduplicator.html#t:t/0"},{"type":"module","title":"Runbox.Master","doc":"Utilities for communicating with master node from slave node","ref":"Runbox.Master.html"},{"type":"function","title":"Runbox.Master.call/4","doc":"Calls a function on the master.\n\nCalls MFA on the `master`. See `:erpc.call/4` for details.","ref":"Runbox.Master.html#call/4"},{"type":"module","title":"Runbox.RunContext","doc":"Structure holding Runbox context of running slave node.","ref":"Runbox.RunContext.html"},{"type":"type","title":"Runbox.RunContext.t/0","doc":"Context of running run slave node.\n\n  * `:master_node` - master node of run\n  * `:node` - slave node of run\n  * `:sup_pid` - pid of supervisor (running on slave) for run components running on slave\n  * `:save_entity_mf` - callback definition (module and function name) for saving entity\n    state. Function is always called with 2 params: entity (`t:Runbox.StateStore.Entity.t/0`)\n    and savepoint timestamp.","ref":"Runbox.RunContext.html#t:t/0"},{"type":"module","title":"Runbox.RunNode","doc":"Module contains common functions called on run slave node.","ref":"Runbox.RunNode.html"},{"type":"function","title":"Runbox.RunNode.start_run_component/3","doc":"Starts run component under run scenario.","ref":"Runbox.RunNode.html#start_run_component/3"},{"type":"function","title":"Runbox.RunNode.start_run_sup/1","doc":"Starts supervisor for run.\n\nAll components of run running on slave node will run under this supervisor.\nOneForAll strategy with 0 max restart stops supervisor if any component crashes.\nBecause run manager process running on master is linked with this supervisor,\nit also crashes (and it what we want).","ref":"Runbox.RunNode.html#start_run_sup/1"},{"type":"module","title":"Runbox.RunStartContext","doc":"Structure holding context of starting run.\n\nThis structure is passed as param to every run component start.","ref":"Runbox.RunStartContext.html"},{"type":"function","title":"Runbox.RunStartContext.add_component/3","doc":"Adds pid of component identified by `name` to context.","ref":"Runbox.RunStartContext.html#add_component/3"},{"type":"function","title":"Runbox.RunStartContext.component_pid/2","doc":"Returns pid of component identitfied by `name`.","ref":"Runbox.RunStartContext.html#component_pid/2"},{"type":"type","title":"Runbox.RunStartContext.t/0","doc":"Currently context holds only mapping of names to pids of already started components.","ref":"Runbox.RunStartContext.html#t:t/0"},{"type":"behaviour","title":"Runbox.Runtime.ComponentNetwork","doc":"Component network builds and validates run component dependency network.\n\nTo build this network, module uses dependencies defined by the scenario.","ref":"Runbox.Runtime.ComponentNetwork.html"},{"type":"callback","title":"Runbox.Runtime.ComponentNetwork.convert_to_network/1","doc":"","ref":"Runbox.Runtime.ComponentNetwork.html#c:convert_to_network/1"},{"type":"function","title":"Runbox.Runtime.ComponentNetwork.convert_to_network/2","doc":"Creates base network with only template nodes","ref":"Runbox.Runtime.ComponentNetwork.html#convert_to_network/2"},{"type":"callback","title":"Runbox.Runtime.ComponentNetwork.create/2","doc":"","ref":"Runbox.Runtime.ComponentNetwork.html#c:create/2"},{"type":"function","title":"Runbox.Runtime.ComponentNetwork.create/3","doc":"Main function. Given list of template modules,\nexpands them into components network with input streams, timezips etc...","ref":"Runbox.Runtime.ComponentNetwork.html#create/3"},{"type":"function","title":"Options - Runbox.Runtime.ComponentNetwork.create/3","doc":"* `:direct_ticking` - if true (default), creates network using direct ticking","ref":"Runbox.Runtime.ComponentNetwork.html#create/3-options"},{"type":"callback","title":"Runbox.Runtime.ComponentNetwork.input_topics/1","doc":"","ref":"Runbox.Runtime.ComponentNetwork.html#c:input_topics/1"},{"type":"function","title":"Runbox.Runtime.ComponentNetwork.input_topics/2","doc":"Return all input topic names that are being subscribed to in component network.","ref":"Runbox.Runtime.ComponentNetwork.html#input_topics/2"},{"type":"function","title":"Runbox.Runtime.ComponentNetwork.topology_sort/2","doc":"","ref":"Runbox.Runtime.ComponentNetwork.html#topology_sort/2"},{"type":"type","title":"Runbox.Runtime.ComponentNetwork.component/0","doc":"","ref":"Runbox.Runtime.ComponentNetwork.html#t:component/0"},{"type":"type","title":"Runbox.Runtime.ComponentNetwork.t/0","doc":"","ref":"Runbox.Runtime.ComponentNetwork.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.OutputAction","doc":"Output Action for internal use by Runtime","ref":"Runbox.Runtime.OutputAction.html"},{"type":"function","title":"Runbox.Runtime.OutputAction.is_oa_body?/1","doc":"Returns `true` if valid output action body.","ref":"Runbox.Runtime.OutputAction.html#is_oa_body?/1"},{"type":"function","title":"Runbox.Runtime.OutputAction.new/4","doc":"Creates a new output action.\n\nTo produce a valid output action, the `params` have to be one of the accepted\nstructs. See the documentation of the particular structs for details.\n\nIf the `params` are not one of the accepted structs or some of the fields do\nnot pass validation, it returns an output action with body set to\n`t:Runbox.Scenario.OutputAction.BadOutputAction.t/0` with original params\ninside.","ref":"Runbox.Runtime.OutputAction.html#new/4"},{"type":"function","title":"Runbox.Runtime.OutputAction.valid?/1","doc":"Returns `true` if valid output action.","ref":"Runbox.Runtime.OutputAction.html#valid?/1"},{"type":"type","title":"Runbox.Runtime.OutputAction.t/0","doc":"Runtime Output Action","ref":"Runbox.Runtime.OutputAction.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.Stage.ComponentNetwork","doc":"Component network builds and validates template dependency network.\n\nTo build this network, module uses `c:Runbox.Scenario.Template.StageBased.subscriptions/0`.\nOnly templates are defined at first, logic than derive input-topic nodes, timezip where one\ntemplate subscribes to two stream, and output sink in the end.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html"},{"type":"function","title":"Runbox.Runtime.Stage.ComponentNetwork.convert_to_network/1","doc":"Creates base network with only template nodes","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#convert_to_network/1"},{"type":"function","title":"Runbox.Runtime.Stage.ComponentNetwork.create/2","doc":"Main function. Given list of template modules,\nexpands them into components network with input streams, timezips etc...","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#create/2"},{"type":"function","title":"Options - Runbox.Runtime.Stage.ComponentNetwork.create/2","doc":"* `:direct_ticking` - if true (default), creates network using direct ticking","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#create/2-options"},{"type":"function","title":"Runbox.Runtime.Stage.ComponentNetwork.input_topics/1","doc":"Return all input topic names that are being subscribed to in component network.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#input_topics/1"},{"type":"function","title":"Runbox.Runtime.Stage.ComponentNetwork.topology_sort/1","doc":"Sorts components (keys) of component network topologicaly, but according to backward edges,\nbecause edge means subscription relation (not comes after but comes before).\nSo instead of indegree implementation use outdegee. Its wrath of kahn's algorithm.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#topology_sort/1"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.component/0","doc":"Full representation of particular component.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:component/0"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.component_type/0","doc":"Part of component identifier.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:component_type/0"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.subscription/0","doc":"Subscription edge defined with destination and props.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:subscription/0"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.subscription_properties/0","doc":"Additional properties of subscription/edge. E.g. selector for Broadcast dispatcher.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:subscription_properties/0"},{"type":"type","title":"Runbox.Runtime.Stage.ComponentNetwork.t/0","doc":"Component network is adjacency graph with subscription edges.","ref":"Runbox.Runtime.Stage.ComponentNetwork.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe","doc":"Transform valid component network to gen_stage definitions.","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html"},{"type":"function","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component_name/1","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#component_name/1"},{"type":"function","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.create/1","doc":"Transform valid component network to gen_stage definitions.","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#create/1"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:component/0"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.component_network/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:component_network/0"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.StartRecipe.subscription/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.StartRecipe.html#t:subscription/0"},{"type":"module","title":"Runbox.Runtime.Stage.SelectorBuilder","doc":"Selector function generator which is used to filter messages between GenStage phases.\n\nStage based runtime uses BroadcastDispatcher to dispatch messages between TemplateCarriers,\nthis kind of dispatcher support message selector function to be passed as part of GenStage\nsubscription. This module is used to generate this function based on template configuration.","ref":"Runbox.Runtime.Stage.SelectorBuilder.html"},{"type":"function","title":"Runbox.Runtime.Stage.SelectorBuilder.build/1","doc":"Builds GenStages BroadcastDispatcher filter function based on template configuration.\n\nFilter function is produced based on `c:Runbox.Scenario.Template.StageBased.subscriptions/0`\ncallback result.\n\nSubscription is defined as {message_type, _routing_rule}, we use only message_type part\nof subscription. All message types are stored in produced function clojure and dispatched\nmessage type is matched against them.\n\nException to the message type matching are output actions and tick messages which are\nalways matched.","ref":"Runbox.Runtime.Stage.SelectorBuilder.html#build/1"},{"type":"module","title":"Runbox.Runtime.Stage.StateGenerator","doc":"Module generates state of run components running on slave node.","ref":"Runbox.Runtime.Stage.StateGenerator.html"},{"type":"function","title":"Runbox.Runtime.Stage.StateGenerator.generate_for_component/2","doc":"Generates state for component template.","ref":"Runbox.Runtime.Stage.StateGenerator.html#generate_for_component/2"},{"type":"module","title":"Runbox.Runtime.Stage.TemplateCarrier","doc":"Module implements producer_consumer GenStage behaviour, scenario template is used to handle events\n\nEvery scenario template is represented in stage based runtime by this module. TemplateCarrier uses\n`Runbox.Runtime.Stage.UnitRegistry` as its state (packed in `Runbox.StateStore.Entity`\nenvelope for `StateStore` usage). `UnitRegistry` provides functionality to lookup units via\nsubscriptions defined in scenario template.\n\nIf unit is located for given message,\n`c:Runbox.Scenario.Template.StageBased.handle_message/2` is used to handle this message. When\nthere is no registered unit for given routing key,\n`c:Runbox.Scenario.Template.StageBased.handle_asset_discovery/1` is used instead.\n\nThe state is updated in `Runbox.StateStore.Entity` with\n`Runbox.StateStore.Entity.update_state/3` after every message is processed. Additionally,\nbefore a message is processed it is confirmed that all messages with lower timestamps were\nprocessed. This is done with `Runbox.StateStore.Entity.ack_processed_time/3` and can result in\nsaving the state in state store.","ref":"Runbox.Runtime.Stage.TemplateCarrier.html"},{"type":"function","title":"Runbox.Runtime.Stage.TemplateCarrier.component_name/1","doc":"","ref":"Runbox.Runtime.Stage.TemplateCarrier.html#component_name/1"},{"type":"function","title":"Runbox.Runtime.Stage.TemplateCarrier.start_link/3","doc":"","ref":"Runbox.Runtime.Stage.TemplateCarrier.html#start_link/3"},{"type":"module","title":"Runbox.Runtime.Stage.TemplateImpl","doc":"Module encapsulates scenario template callback calls.\n\nScenario defines `Toolbox.Runtime.Stage.Unit` as state carrier, these units are organized\ninto `Runbox.Runtime.Stage.UnitRegistry` which is helper structure to route messages between\nunits managed by one template.\n\nMessages are handled via `Runbox.Scenario.Template.StageBased` callbacks. We distinguish two\ntypes of messages = message to existing unit and message to new unit (asset discovery).\n\nMessages that doesn't have any unit registered and thus found to handle them, we call this\nsituation asset discovery and use `c:Runbox.Scenario.Template.StageBased.handle_asset_discovery/1`\ncallback to handle these message. New unit may or may not be created here, but when it does,\nit needs to be initialized via `c:Runbox.Scenario.Template.StageBased.init/2` callback.\n\nWhen there is at least one unit which is registered to the message, we use callback\n`c:Runbox.Scenario.Template.StageBased.handle_message/2`. Unit may be updated or stopped here.\n\nWe support timeouts to be defined. These timeouts are triggered via `external` time, which is\nderived from incoming message timestamps. Timeouts are registered for one unit.\n\nSome output actions produced by any of template callback should be further updated. Events\nrequire filling `run id` and notifications require `scenario id` to be filled.","ref":"Runbox.Runtime.Stage.TemplateImpl.html"},{"type":"function","title":"Runbox.Runtime.Stage.TemplateImpl.handle_message/6","doc":"","ref":"Runbox.Runtime.Stage.TemplateImpl.html#handle_message/6"},{"type":"function","title":"Runbox.Runtime.Stage.TemplateImpl.init_state/5","doc":"","ref":"Runbox.Runtime.Stage.TemplateImpl.html#init_state/5"},{"type":"module","title":"Runbox.Runtime.Stage.Timezip","doc":"Timezip component responsible for merging messages from multiple sources using message timestamps.","ref":"Runbox.Runtime.Stage.Timezip.html"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.component_name/1","doc":"","ref":"Runbox.Runtime.Stage.Timezip.html#component_name/1"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.start_link/3","doc":"","ref":"Runbox.Runtime.Stage.Timezip.html#start_link/3"},{"type":"module","title":"Runbox.Runtime.Stage.Timezip.MultiQueue","doc":"Buffering multi-queue data structure for Timezip.\n\nIf the structure would be heap, the complexity would be Olog(N) where N is number of messages\n(topped by max demand).\nWith multi-queue operation is ~ O(M) where M is number of producers.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.add_queue/2","doc":"Adds new queue to MultiQueue.\n\nIf adding same id again -> clears buffered messages for given producer.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#add_queue/2"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.dequeue_all/2","doc":"Main logic, will return messages from all queues zipped/sorted by min timestamp.\n\nWill return as many messages as possible, until some queue is empty.\n\nIn returned tuple, returned values means:\n - *multi_queue:* multi-queue without emitted messages\n\n - *demand_distribution:* map with `id -> integer()`, meaning how many messages in output\n   originates from particular queue id, can be used for manual demand handling in genstage\n\n - *emitted:* returned messages from multiqueue front","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#dequeue_all/2"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.enqueue/3","doc":"Adds messages for queue id to multiqueue.","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#enqueue/3"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.new/0","doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#new/0"},{"type":"function","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.remove_queue/2","doc":"Removes queue and its content from multi_queue","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#remove_queue/2"},{"type":"type","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.demand_distribution/0","doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#t:demand_distribution/0"},{"type":"type","title":"Runbox.Runtime.Stage.Timezip.MultiQueue.t/0","doc":"","ref":"Runbox.Runtime.Stage.Timezip.MultiQueue.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.Stage.UnitRegistry","doc":"Unit register used in stage based runtime to manage state of units.\n\nUnitRegistry is configured via `c:Runbox.Scenario.Template.StageBased.subscriptions/0` callback\nresult. Callback returns template subscriptions, each subscription is defined as\n{message_type, routing_rule}. Unit registry contains one register per configured message_type.\nRouting rule is used to store unit and later on lookup this unit when needed.\n\nUnits are being registered using unit attributes as defined in routing_rule. Unit lookup uses\nrouting_rule to parse message body and the result compares to stored unit attributes.","ref":"Runbox.Runtime.Stage.UnitRegistry.html"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.get_unit/2","doc":"Returns unit with given id.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#get_unit/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.init/1","doc":"Initialize UnitRegistry non-persisted fields.\n\nThis needs to be called right before starting new unit registry (done in `new/1` automatically)\nand also after loading UnitRegistry from savepoint. This is needed because not all fields are\npersisted into a savepoint.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#init/1"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.lookup/2","doc":"Searches for registered unit in the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#lookup/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.new/1","doc":"Creates new unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#new/1"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.pop_reached_timeout/2","doc":"Returns first reached timeout and removes it from unit registry in one operation.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#pop_reached_timeout/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.register/2","doc":"Registers given unit to the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#register/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.register_timeout/4","doc":"Registers timeout.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#register_timeout/4"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.reregister/2","doc":"Reregisters unit in the unit registry.\n\nFunction updates alternative registers using new version of unit attributes. Timeouts will remain\nuntouched.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#reregister/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.unregister/2","doc":"Unregisters given unit from the unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#unregister/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.update/2","doc":"Updates unit in unit registry.","ref":"Runbox.Runtime.Stage.UnitRegistry.html#update/2"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.msg_parser/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:msg_parser/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.path/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:path/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.routing_key/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:routing_key/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.routing_key_def/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:routing_key_def/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.t/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:t/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.unit_id/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:unit_id/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.unit_register/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.html#t:unit_register/0"},{"type":"module","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry","doc":"Module manages alternative registry state.\n\nEvery unit is registered only once per alternative registry. More than one unit can be registered\nwith the same key.","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.lookup/2","doc":"Get registered unit ids","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#lookup/2"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.new/0","doc":"Returns new alternative registry","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#new/0"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.register_unit/3","doc":"Registers unit in alternative reg with given key","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#register_unit/3"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.unregister_unit/2","doc":"Unregisters unit from alternative reg","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#unregister_unit/2"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.registration_key/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:registration_key/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.t/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:t/0"},{"type":"type","title":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.unit_id/0","doc":"","ref":"Runbox.Runtime.Stage.UnitRegistry.AlternativeRegistry.html#t:unit_id/0"},{"type":"module","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder","doc":"Builder of msg_parser and unit_register fns used in `Runbox.Runtime.Stage.UnitRegistry`\n\n- message_parser is lambda function used to parse `Toolbox.Message` and creates key to find unit\nin unit registry\n- unit_register is lambda function used to parse `Toolbox.Runtime.Stage.Unit` and creates key\nto store unit in unit registry","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.build_msg_parser/1","doc":"Gets routing key definition as argument and returns msg_parser lambda function\n\nLambda takes `Toolbox.Message` as argument and returns list of message body values based on\nprovided routing key definition.\n\niex> msg_parser_fn =\n...> RoutingKeyBuilder.build_msg_parser({:=, [[:foo]], [[:bar]]})\n...> msg_parser_fn.(%Message{body: %{foo: \"message_body_key_value\"}})\n[\"message_body_key_value\"]\n\niex> msg_parser_fn =\n...> RoutingKeyBuilder.build_msg_parser({:in, [[:foo]], [[:bar]]})\n...> msg_parser_fn.(%Message{body: %{foo: \"message_body_key_value\"}})\n[\"message_body_key_value\"]","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html#build_msg_parser/1"},{"type":"function","title":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.build_unit_register/1","doc":"Gets routing key definition as argument and returns unit_register lambda function\n\nLambda takes alternative registers (unit indexes), alternative register name,\n`Toolbox.Runtime.Stage.Unit` as arguments and returns updated alternative registers based on\nprovided routing key definition.\n\niex> unit_register_fn =\n...> RoutingKeyBuilder.build_unit_register({:=, [[:foo]], [[:bar]]})\n...> unit = %Unit{id: \"unit_id\", attributes: %{bar: \"attribute_key_value\"}}\n...> unit_register_fn.(%{\"alt_reg\" => AlternativeRegistry.new()}, \"alt_reg\", unit)\n%{\"alt_reg\" => %{[\"attribute_key_value\"] => [\"unit_id\"]}}\n\niex> unit_register_fn =\n...> RoutingKeyBuilder.build_unit_register({:in, [[:foo]], [[:bar]]})\n...> unit = %Unit{id: \"unit_id\", attributes: %{bar: [\"value_1\", \"value_2\"]}}\n...> unit_register_fn.(%{\"alt_reg\" => AlternativeRegistry.new()}, \"alt_reg\", unit)\n%{\"alt_reg\" => %{[\"value_1\"] => [\"unit_id\"], [\"value_2\"] => [\"unit_id\"]}}","ref":"Runbox.Runtime.Stage.UnitRegistry.RoutingKeyBuilder.html#build_unit_register/1"},{"type":"module","title":"Runbox.Scenario","doc":"Holds information about scenario.","ref":"Runbox.Scenario.html"},{"type":"function","title":"Runbox.Scenario.get_impl_for/1","doc":"","ref":"Runbox.Scenario.html#get_impl_for/1"},{"type":"function","title":"Runbox.Scenario.manifest_module?/1","doc":"","ref":"Runbox.Scenario.html#manifest_module?/1"},{"type":"function","title":"Runbox.Scenario.template_module?/2","doc":"","ref":"Runbox.Scenario.html#template_module?/2"},{"type":"type","title":"Runbox.Scenario.component_def/0","doc":"","ref":"Runbox.Scenario.html#t:component_def/0"},{"type":"type","title":"Runbox.Scenario.t/0","doc":"","ref":"Runbox.Scenario.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.Notification","doc":"Module contains functions for working with scenario notifications.","ref":"Runbox.Scenario.Notification.html"},{"type":"function","title":"Runbox.Scenario.Notification.list_channels/3","doc":"Lists all channels with templates defined for scenario, notification type and template type.","ref":"Runbox.Scenario.Notification.html#list_channels/3"},{"type":"function","title":"Runbox.Scenario.Notification.list_languages/4","doc":"Lists all template languages defined for scenario, notification type, template type and channel.","ref":"Runbox.Scenario.Notification.html#list_languages/4"},{"type":"function","title":"Runbox.Scenario.Notification.list_notification_types/1","doc":"Lists all notification types for a scenario.","ref":"Runbox.Scenario.Notification.html#list_notification_types/1"},{"type":"function","title":"Runbox.Scenario.Notification.list_template_types/2","doc":"Lists all template types of the specified notification.","ref":"Runbox.Scenario.Notification.html#list_template_types/2"},{"type":"function","title":"Runbox.Scenario.Notification.load_and_eval_templates/7","doc":"Loads and evaluates templates specified by scenario, notification type, template type, channel\nand language.\n\nIf language is not defined or does not exist, `fallback_language` is used.","ref":"Runbox.Scenario.Notification.html#load_and_eval_templates/7"},{"type":"behaviour","title":"Runbox.Scenario.TemplateInspector","doc":"Behaviour used to detect scenario template source files.","ref":"Runbox.Scenario.TemplateInspector.html"},{"type":"callback","title":"Runbox.Scenario.TemplateInspector.template_info/1","doc":"","ref":"Runbox.Scenario.TemplateInspector.html#c:template_info/1"},{"type":"function","title":"Runbox.Scenario.TemplateInspector.template_info/2","doc":"Retrieve implementation specific information about a template.","ref":"Runbox.Scenario.TemplateInspector.html#template_info/2"},{"type":"callback","title":"Runbox.Scenario.TemplateInspector.valid_template?/1","doc":"","ref":"Runbox.Scenario.TemplateInspector.html#c:valid_template?/1"},{"type":"function","title":"Runbox.Scenario.TemplateInspector.valid_template?/2","doc":"Validate whether given module is valid template source file.","ref":"Runbox.Scenario.TemplateInspector.html#valid_template?/2"},{"type":"module","title":"Runbox.ScenarioRelease","doc":"Module for inspecting a scenario release.","ref":"Runbox.ScenarioRelease.html"},{"type":"function","title":"Runbox.ScenarioRelease.release_info/1","doc":"Retrieves information about scenarios in a release.","ref":"Runbox.ScenarioRelease.html#release_info/1"},{"type":"module","title":"Runbox.ScenarioRelease.SlaveFunc","doc":"Functions which are called on the scenario slave via RPC from the master\nnode.","ref":"Runbox.ScenarioRelease.SlaveFunc.html"},{"type":"function","title":"Runbox.ScenarioRelease.SlaveFunc.release_info/1","doc":"","ref":"Runbox.ScenarioRelease.SlaveFunc.html#release_info/1"},{"type":"function","title":"Runbox.ScenarioRelease.SlaveFunc.scenarios/0","doc":"Returns list of scenarios in release.","ref":"Runbox.ScenarioRelease.SlaveFunc.html#scenarios/0"},{"type":"module","title":"Runbox.ScenarioTemplate","doc":"Holds information about scenario template.","ref":"Runbox.ScenarioTemplate.html"},{"type":"type","title":"Runbox.ScenarioTemplate.t/0","doc":"","ref":"Runbox.ScenarioTemplate.html#t:t/0"},{"type":"module","title":"Runbox.Slave","doc":"Utilities for starting a slave node with a scenario release and communicating\nwith the node.","ref":"Runbox.Slave.html"},{"type":"function","title":"Runbox.Slave.call/4","doc":"Calls a function on the slave.\n\nCalls MFA on the `slave`. See `:erpc.call/4` for details.","ref":"Runbox.Slave.html#call/4"},{"type":"function","title":"Runbox.Slave.start/2","doc":"Starts a slave node.\n\nThe `release_dir` is a directory with scenario release.\n\nIf `app_env` is set, given app environment variables are set on slave.","ref":"Runbox.Slave.html#start/2"},{"type":"function","title":"Runbox.Slave.with_slave/2","doc":"Spawns a slave and executes the `fun`.\n\n`fun` receives the slave node as a parameter. The slave is terminated after\nthe `fun` finishes.","ref":"Runbox.Slave.html#with_slave/2"},{"type":"module","title":"Runbox.StateStore.Entity","doc":"Module defines struct which acts as state store envelope for any stateful runtime component.","ref":"Runbox.StateStore.Entity.html"},{"type":"function","title":"Runbox.StateStore.Entity.ack_processed_time/3","doc":"Confirm that all messages with lower timestamps were processed.\n\nWhen the timestamp is higher than next savepoint the state is persisted into `StateStore` with\n`StateStore.save/4` and next savepoint target is determined and stored in the entity.\nThe state is persisted only once per every savepoint.","ref":"Runbox.StateStore.Entity.html#ack_processed_time/3"},{"type":"function","title":"Runbox.StateStore.Entity.id/1","doc":"Returns entity id","ref":"Runbox.StateStore.Entity.html#id/1"},{"type":"function","title":"Runbox.StateStore.Entity.new/5","doc":"Creates new state store entity","ref":"Runbox.StateStore.Entity.html#new/5"},{"type":"function","title":"Runbox.StateStore.Entity.schedule/1","doc":"Returns entity schedule","ref":"Runbox.StateStore.Entity.html#schedule/1"},{"type":"function","title":"Runbox.StateStore.Entity.state/1","doc":"Returns entity state","ref":"Runbox.StateStore.Entity.html#state/1"},{"type":"function","title":"Runbox.StateStore.Entity.timestamp/1","doc":"Returns entity timestamp","ref":"Runbox.StateStore.Entity.html#timestamp/1"},{"type":"function","title":"Runbox.StateStore.Entity.update_state/3","doc":"Set entity `state` at the specified point in time.","ref":"Runbox.StateStore.Entity.html#update_state/3"},{"type":"type","title":"Runbox.StateStore.Entity.id/0","doc":"","ref":"Runbox.StateStore.Entity.html#t:id/0"},{"type":"type","title":"Runbox.StateStore.Entity.state/0","doc":"","ref":"Runbox.StateStore.Entity.html#t:state/0"},{"type":"type","title":"Runbox.StateStore.Entity.t/0","doc":"","ref":"Runbox.StateStore.Entity.html#t:t/0"},{"type":"module","title":"Runbox.StateStore.ScheduleUtils","doc":"Module contains functions to compute savepoint timestamps.\n\nSavepoint timestamps are calculated as multiples of `schedule`.","ref":"Runbox.StateStore.ScheduleUtils.html"},{"type":"function","title":"Runbox.StateStore.ScheduleUtils.next_savepoint/2","doc":"Returns next savepoint based on given `schedule` and `timestamp`.\n\nNext savepoint is calculated as next multiple of `schedule` larger or equal to given\n`timestamp`.","ref":"Runbox.StateStore.ScheduleUtils.html#next_savepoint/2"},{"type":"function","title":"Examples - Runbox.StateStore.ScheduleUtils.next_savepoint/2","doc":"```\niex> Runbox.StateStore.ScheduleUtils.next_savepoint(60_000, 0)\n60_000\n\niex> Runbox.StateStore.ScheduleUtils.next_savepoint(60_000, 10_000)\n60_000\n\niex> Runbox.StateStore.ScheduleUtils.next_savepoint(60_000, 60_000)\n120_000\n```","ref":"Runbox.StateStore.ScheduleUtils.html#next_savepoint/2-examples"},{"type":"function","title":"Runbox.StateStore.ScheduleUtils.previous_savepoint/2","doc":"Returns previous savepoint based on given `schedule` and `timestamp`.\n\nNext savepoint is calculated as previous multiple of `schedule` lower or equal to given\n`timestamp`.","ref":"Runbox.StateStore.ScheduleUtils.html#previous_savepoint/2"},{"type":"function","title":"Examples - Runbox.StateStore.ScheduleUtils.previous_savepoint/2","doc":"```\niex> Runbox.StateStore.ScheduleUtils.previous_savepoint(60_000, 30_000)\n0\n\niex> Runbox.StateStore.ScheduleUtils.previous_savepoint(60_000, 60_000)\n60_000\n\niex> Runbox.StateStore.ScheduleUtils.previous_savepoint(60_000, 90_000)\n60_000\n\niex> Runbox.StateStore.ScheduleUtils.previous_savepoint(60_000, 120_000)\n120_000\n\niex> Runbox.StateStore.ScheduleUtils.previous_savepoint(60_000, 150_000)\n120_000\n```","ref":"Runbox.StateStore.ScheduleUtils.html#previous_savepoint/2-examples"},{"type":"function","title":"Runbox.StateStore.ScheduleUtils.unreached_savepoints/3","doc":"Returns unreached savepoints based on given `schedule` in range of given timestamps `(from; to>`","ref":"Runbox.StateStore.ScheduleUtils.html#unreached_savepoints/3"},{"type":"function","title":"Examples - Runbox.StateStore.ScheduleUtils.unreached_savepoints/3","doc":"```\niex> Runbox.StateStore.ScheduleUtils.unreached_savepoints(60_000, 0, 120_000)\n[60_000, 120_000]\n\niex> Runbox.StateStore.ScheduleUtils.unreached_savepoints(60_000, 60_000, 120_000)\n[120_000]\n\niex> Runbox.StateStore.ScheduleUtils.unreached_savepoints(60_000, 60_000, 180_000)\n[120_000, 180_000]\n```","ref":"Runbox.StateStore.ScheduleUtils.html#unreached_savepoints/3-examples"},{"type":"function","title":"Runbox.StateStore.ScheduleUtils.unreached_savepoints_count/3","doc":"Returns count of unreached savepoints.","ref":"Runbox.StateStore.ScheduleUtils.html#unreached_savepoints_count/3"},{"type":"function","title":"Examples - Runbox.StateStore.ScheduleUtils.unreached_savepoints_count/3","doc":"```\niex> Runbox.StateStore.ScheduleUtils.unreached_savepoints_count(60_000, 0, 120_000)\n2\n\niex> Runbox.StateStore.ScheduleUtils.unreached_savepoints_count(60_000, 60_000, 120_000)\n1\n\niex> Runbox.StateStore.ScheduleUtils.unreached_savepoints_count(1, 0, 120_000)\n120_000\n```","ref":"Runbox.StateStore.ScheduleUtils.html#unreached_savepoints_count/3-examples"},{"type":"type","title":"Runbox.StateStore.ScheduleUtils.epoch_ms/0","doc":"Timestamp defined as unix epoch in milliseconds","ref":"Runbox.StateStore.ScheduleUtils.html#t:epoch_ms/0"},{"type":"type","title":"Runbox.StateStore.ScheduleUtils.epoch_ms_interval/0","doc":"Difference between two unix epoch timestamps in milliseconds","ref":"Runbox.StateStore.ScheduleUtils.html#t:epoch_ms_interval/0"},{"type":"type","title":"Runbox.StateStore.ScheduleUtils.schedule/0","doc":"Interval (in seconds) between savepoint timestamps.","ref":"Runbox.StateStore.ScheduleUtils.html#t:schedule/0"},{"type":"module","title":"Toolbox.ErrorMessage","doc":"Dead-letter message produced when evaluating of raw-topic failed.","ref":"Toolbox.ErrorMessage.html"},{"type":"type","title":"Toolbox.ErrorMessage.t/0","doc":"","ref":"Toolbox.ErrorMessage.html#t:t/0"},{"type":"module","title":"Toolbox.JitterMessage","doc":"Formerly delayed messages/late events, when jitter around incoming topic is out of threshold.\n\nNegative delay means message is too late (from past). Positive delay means message is too early\n(from future).\n\nNormalized messages is provided.","ref":"Toolbox.JitterMessage.html"},{"type":"type","title":"Toolbox.JitterMessage.t/0","doc":"See module `Toolbox.JitterMessage` info.","ref":"Toolbox.JitterMessage.html#t:t/0"},{"type":"module","title":"Toolbox.Message","doc":"Altworx message runtime representation.","ref":"Toolbox.Message.html"},{"type":"function","title":"Toolbox.Message.body/1","doc":"","ref":"Toolbox.Message.html#body/1"},{"type":"function","title":"Toolbox.Message.from/1","doc":"","ref":"Toolbox.Message.html#from/1"},{"type":"function","title":"Toolbox.Message.new/4","doc":"","ref":"Toolbox.Message.html#new/4"},{"type":"function","title":"Toolbox.Message.timestamp/1","doc":"","ref":"Toolbox.Message.html#timestamp/1"},{"type":"function","title":"Toolbox.Message.type/1","doc":"","ref":"Toolbox.Message.html#type/1"},{"type":"type","title":"Toolbox.Message.body/0","doc":"","ref":"Toolbox.Message.html#t:body/0"},{"type":"type","title":"Toolbox.Message.from/0","doc":"","ref":"Toolbox.Message.html#t:from/0"},{"type":"type","title":"Toolbox.Message.origin/0","doc":"","ref":"Toolbox.Message.html#t:origin/0"},{"type":"type","title":"Toolbox.Message.t/0","doc":"","ref":"Toolbox.Message.html#t:t/0"},{"type":"type","title":"Toolbox.Message.timestamp/0","doc":"","ref":"Toolbox.Message.html#t:timestamp/0"},{"type":"type","title":"Toolbox.Message.type/0","doc":"","ref":"Toolbox.Message.html#t:type/0"},{"type":"module","title":"Runbox.Runtime.RuntimeInstruction","doc":"Struct produced by scenario representing instruction for runtime.","ref":"Runbox.Runtime.RuntimeInstruction.html"},{"type":"function","title":"Runbox.Runtime.RuntimeInstruction.register_timeout/1","doc":"Creates runtime instruction to register timeout message.","ref":"Runbox.Runtime.RuntimeInstruction.html#register_timeout/1"},{"type":"type","title":"Runbox.Runtime.RuntimeInstruction.t/0","doc":"Struct produced by scenario representing instruction for runtime.","ref":"Runbox.Runtime.RuntimeInstruction.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.RuntimeInstruction.Timeout","doc":"Instruction to register unit timeout.","ref":"Runbox.Runtime.RuntimeInstruction.Timeout.html"},{"type":"type","title":"Runbox.Runtime.RuntimeInstruction.Timeout.t/0","doc":"Struct representing unit timeout registration.","ref":"Runbox.Runtime.RuntimeInstruction.Timeout.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction","doc":"Output action represents a side effect produced by a run.","ref":"Runbox.Scenario.OutputAction.html"},{"type":"module","title":"Creating output actions - Runbox.Scenario.OutputAction","doc":"Creating output action typically happens from scenario. It is done by\ncreating one of the appropriate struct:\n\n  * `t:Runbox.Scenario.OutputAction.UpsertAssetAttributes.t/0`\n  * `t:Runbox.Scenario.OutputAction.DeleteAssetAttributes.t/0`\n  * `t:Runbox.Scenario.OutputAction.DeleteAllAssetAttributes.t/0`\n  * `t:Runbox.Scenario.OutputAction.UpsertEdge.t/0`\n  * `t:Runbox.Scenario.OutputAction.DeleteEdge.t/0`\n  * `t:Runbox.Scenario.OutputAction.Notification.t/0`\n  * `t:Runbox.Scenario.OutputAction.Event.t/0`\n  * `t:Runbox.Scenario.OutputAction.ExecuteSQL.t/0`\n  * `t:Runbox.Scenario.OutputAction.Incident.t/0`\n  * `t:Runbox.Scenario.OutputAction.IncidentPatch.t/0`\n\nFor example:\n\n    iex> %OutputAction.UpsertAssetAttributes{\n    ...>   type: \"/asset/camera\",\n    ...>   id: \"one\",\n    ...>   attributes: %{\"foo\" => \"bar\"}\n    ...> }","ref":"Runbox.Scenario.OutputAction.html#module-creating-output-actions"},{"type":"module","title":"Asset and edge output actions - Runbox.Scenario.OutputAction","doc":"Changes done by output actions to assets and edges are scoped for each\nscenario run. The global result is computed from the changes done by\nindividual runs.\n\nA single run is forbidden to do multiple changes to the same object (asset\nattribute or edge) at the same time. However distinct runs can perform such\nchanges, because they are scoped to each run.\n\nThe rules to compute the global state apply in the following order:\n\n  1. Change with the higher timestamp has precedence.\n\n  1. Updating an asset attribute or an edge has precedence to deleting it.\n\n  1. Change with the higher value has precedence (applies only for asset attributes).","ref":"Runbox.Scenario.OutputAction.html#module-asset-and-edge-output-actions"},{"type":"type","title":"Runbox.Scenario.OutputAction.asset_id/0","doc":"","ref":"Runbox.Scenario.OutputAction.html#t:asset_id/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.asset_type/0","doc":"","ref":"Runbox.Scenario.OutputAction.html#t:asset_type/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.edge_type/0","doc":"","ref":"Runbox.Scenario.OutputAction.html#t:edge_type/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.interpolable/0","doc":"String with interpolation support.\n\nSupports interpolating asset references to a format which is useful for\ndisplaying assets in the Altworx UI. The string can contain any number of\nplaceholders in format\n\n    ${assets.[\"/assets/camera\", \"one\"]}\n\nWhere `\"/assets/camera\"` is the asset type and `\"one\"` is the asset ID. The resulting interpolation is\n\n    [Camera One[/assets/camera/one]]\n\nWhere `Camera One` is the asset's `name` attribute and `/assets/camera/one`\nis the asset's full ID. When the asset `name` is not present, the asset's ID\nis used instead\n\n    [one[/assets/camera/one]]\n\nWhen the asset cannot be found, the resulting interpolation is\n\n    unknown\n\nThe interpolation is done upon \"read\" operations, therefore the result can\nvary based on the asset visibility for the identity of the user performing\nthe operation.","ref":"Runbox.Scenario.OutputAction.html#t:interpolable/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.oa_params/0","doc":"","ref":"Runbox.Scenario.OutputAction.html#t:oa_params/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.t/0","doc":"Output Action\n\nThis struct is produced by `Runbox.Runtime.Stage.Sandbox.execute_run/3`.","ref":"Runbox.Scenario.OutputAction.html#t:t/0"},{"type":"module","title":"Toolbox.Scenario.UserAction","doc":"Toolbox for working with scenario user actions.\n\nUser action is action created by scenario via `Runbox.Scenario.UIAction` and fired\nby user (usually from UI). Scenario is usually also a receiver of fired action.\nAssumed workflow is following:\n\n  1) Scenario creates list of actions (using `Runbox.Scenario.UIAction`) to be fired\n     in the future and saves it somewhere (in incident asset for example).\n\n  2) UI displays available actions.\n\n  3) User fires selected action from UI.\n\n  4) UI pushes the action to raw Kafka topic (defined in action) with extra data attached\n     (usually some comment).\n\n  5) Normalizer pipeline receives the action and sends it to target scenario.","ref":"Toolbox.Scenario.UserAction.html"},{"type":"function","title":"Toolbox.Scenario.UserAction.fire/3","doc":"Unpacks action and makes it fired (prepared for sending to target topic).\n\nRouting properties (`type`, `details`) are propagated from packed action, `user` and `data`\nproperties are attached to fired action. Target `topic` is also extracted from packed action.\n\nReturns error if packed action (JWT) is not valid.","ref":"Toolbox.Scenario.UserAction.html#fire/3"},{"type":"function","title":"Toolbox.Scenario.UserAction.normalizer_pipeline_step/1","doc":"Helper for UserAction forwarding to be used in normalizer.\n\nIf helper is used in normalizer pipeline configuration in `config.ini` like\n\n    [pipelines.some_pipeline]\n    definition = Toolbox.Scenario.UserAction.normalizer_pipeline_step\n\nthan `Toolbox.Message` `body` will contain fired `Toolbox.Scenario.UserAction`.","ref":"Toolbox.Scenario.UserAction.html#normalizer_pipeline_step/1"},{"type":"function","title":"Toolbox.Scenario.UserAction.pack/3","doc":"Packs user action to JWT to be used (fired) later (from UI for example).\n\nParameter `details` must be a map encodable to JSON. Because `details` can be (and it is!)\nencoded/decoded to/from JSON during its life-cycle, atom property names of `details` are\nalways converted to string property names in fired action's `details`.\n\nJWT is not used for security reasons - it is just good enough envelope protecting\naction against accidental corruption on its journey.","ref":"Toolbox.Scenario.UserAction.html#pack/3"},{"type":"function","title":"Toolbox.Scenario.UserAction.parse_raw_action/1","doc":"Parses string containing JSON to `Toolbox.Scenario.UserAction`.","ref":"Toolbox.Scenario.UserAction.html#parse_raw_action/1"},{"type":"type","title":"Toolbox.Scenario.UserAction.t/0","doc":"Fired user action.\n\nWhen action is fired by the user, it should be pushed to raw `topic` with current\ntimestamp to be correctly reordered by `Normalizer`. Properties `type` and `details`\nshould contain enough information for routing action to the target scenario. Property\n`user` is ID of user who fired the action, `data` contains extra information attached\nby environment where user fired the action (for example comment filled by the user on UI).","ref":"Toolbox.Scenario.UserAction.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.BadOutputAction","doc":"Body of invalid output action.","ref":"Runbox.Scenario.OutputAction.BadOutputAction.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.BadOutputAction.t/0","doc":"Bad Output Action\n\n  * `:params` - holds the original parameters","ref":"Runbox.Scenario.OutputAction.BadOutputAction.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.DeleteAllAssetAttributes","doc":"Parameters for output action Delete All Asset Attributes.\n\nThe resulting output action will delete all existing attributes of the\ngiven asset. This is scoped to the attributes created by the same run.","ref":"Runbox.Scenario.OutputAction.DeleteAllAssetAttributes.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.DeleteAllAssetAttributes.t/0","doc":"Delete All Asset Attributes\n\n  * `:type` - asset type\n  * `:id` - asset ID","ref":"Runbox.Scenario.OutputAction.DeleteAllAssetAttributes.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.DeleteAssetAttributes","doc":"Parameters for output action Delete Asset Attributes.\n\nThe resulting output action will delete attributes of the given asset. This\naction succeeds even if the attributes do not exist.","ref":"Runbox.Scenario.OutputAction.DeleteAssetAttributes.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.DeleteAssetAttributes.t/0","doc":"Delete Asset Attributes\n\n  * `:type` - asset type\n  * `:id` - asset ID\n  * `:attributes` - a map of attributes to be deleted\n\nThe leaf attributes of the `:attributes` map are deleted.\nE.g., if asset has the following attributes\n```elixir\n%{\n  \"a\": 1,\n  \"b\": %{\"c\" => 2}\n}\n```\nand the following `:attributes` are provided in the output action\n```elixir\n%{\n  \"b\": %{\"c\" => true}\n}\n```\nthen `b.c` attribute will be deleted, resulting in\n```elixir\n%{\n  \"a\": 1\n  \"b\": %{}\n}\n```","ref":"Runbox.Scenario.OutputAction.DeleteAssetAttributes.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.DeleteEdge","doc":"Parameters for output action Delete Edge.\n\nThe resulting output action will delete an edge between two assets. This\naction succeeds even if the edge does not exist.","ref":"Runbox.Scenario.OutputAction.DeleteEdge.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.DeleteEdge.t/0","doc":"Delete Edge\n\n  * `:from_type` - type of the asset which this edge goes out from\n  * `:from_id` - id of the asset which this edge goes out from\n  * `:to_type` - type of the asset which this edge goes to\n  * `:to_id` - id of the asset which this edge goes to\n  * `:type` - type of the edge","ref":"Runbox.Scenario.OutputAction.DeleteEdge.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.Event","doc":"Parameters for output action Event.\n\nThe resulting output action creates an event.","ref":"Runbox.Scenario.OutputAction.Event.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.Event.actor/0","doc":"","ref":"Runbox.Scenario.OutputAction.Event.html#t:actor/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.Event.actors/0","doc":"","ref":"Runbox.Scenario.OutputAction.Event.html#t:actors/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.Event.t/0","doc":"Event\n\n  * `:type` - type of the event. It's declared in Scenario's Manifest.\n  * `:template` - event's template that allows to interpolate actors and parameters\n    (see the *Interpolation* section below).\n  * `:actors` - map of actors that are to be linked with the event. They may also be\n    interpolated in the template.\n  * `:params` - map of template parameters that are interpolated in the template\n    (optional, defaults to `%{}`).\n  * `:origin_messages` - list of references to raw messages linked with the event itself\n    (optional, defaults to `[]`).","ref":"Runbox.Scenario.OutputAction.Event.html#t:t/0"},{"type":"type","title":"Interpolation - Runbox.Scenario.OutputAction.Event.t/0","doc":"The template may reference actors using placeholders like `${actors.actor_key}`, where\n`actor_key` corresponds to a key in the `actors` map within this struct. In the UI,\nthese placeholders are transformed into links. Each link points to the corresponding\nasset and displays the asset's name as the link text.\n\nThe template may also contain placeholders like `${params.param_key}`, where `param_key`\nis a key under the `params` map. These placeholders are simply replaced with the\ncorresponding values from the `params` map. These parameters are useful for dynamic\ncontent other than actors.","ref":"Runbox.Scenario.OutputAction.Event.html#t:t/0-interpolation"},{"type":"type","title":"Example - Runbox.Scenario.OutputAction.Event.t/0","doc":"%Event{\n      type: \"server_login\",\n      template: \"${actors.person} logged into ${actors.server} using OpenSSH ${params.openssh_version}\",\n      actors: %{\n        \"person\" => %{\n          asset_type: \"/assets/person\",\n          asset_id: \"joe\"\n        },\n        \"server\" => %{\n          asset_type: \"/assets/server\",\n          asset_id: \"192.168.142.18\"\n        }\n      },\n      params: %{\"openssh_version\" => \"9.8\"},\n      origin_messages: [normalized_message.origin]\n    }","ref":"Runbox.Scenario.OutputAction.Event.html#t:t/0-example"},{"type":"module","title":"Runbox.Scenario.OutputAction.ExecuteSQL","doc":"Parameters for output action Execute SQL.\n\nThe resulting output action executes an SQL statement.","ref":"Runbox.Scenario.OutputAction.ExecuteSQL.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.ExecuteSQL.t/0","doc":"Execute SQL\n\n  * `:db_connection` - map with database connection info (`hostname`, `username`, `password`, `database`)\n  * `:sql_query` - SQL query.\n  * `:data` - list of parameterized data.\n  * `:type` - database type, right now only PostgreSQL is supported. It's checked in `OutputProcessor` and\n    the value must be `:postgresql`.\n\nIf `:run_id` is present in `data`, it's replaced with actual run_id in `AssetMap.Api.SqlExecutor`.","ref":"Runbox.Scenario.OutputAction.ExecuteSQL.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.Incident","doc":"Parameters for output action Incident.\n\nThe resulting output action creates an incident.","ref":"Runbox.Scenario.OutputAction.Incident.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.Incident.severity/0","doc":"","ref":"Runbox.Scenario.OutputAction.Incident.html#t:severity/0"},{"type":"type","title":"Runbox.Scenario.OutputAction.Incident.t/0","doc":"Incident","ref":"Runbox.Scenario.OutputAction.Incident.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.IncidentActor","doc":"Incident Actor","ref":"Runbox.Scenario.OutputAction.IncidentActor.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.IncidentActor.t/0","doc":"","ref":"Runbox.Scenario.OutputAction.IncidentActor.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.IncidentFuture","doc":"Incident Future","ref":"Runbox.Scenario.OutputAction.IncidentFuture.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.IncidentFuture.t/0","doc":"","ref":"Runbox.Scenario.OutputAction.IncidentFuture.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.IncidentHistory","doc":"Incident history.\n\nThe struct represents a change of an Incident in time. It carries information about how the\nIncident changed, all describe how the Incident looks after the change. The struct contains all\nnecessary parameters to create an Incident history record.\n\nSince Incident history is now synonymous to Events, `event_*` fields of this struct can be used\nto control how the final Event looks like.\n\nAvailable fields\n\n- `:status` - status of the Incident\n- `:severity` - severity of the Incident\n- `:timestamp` - time of the change\n- `:description` - description of the change - what has happened, will be used as Event template\n- `:attributes` - (optional) significant additional attributes that changed with the Incident\n  (usually metrics, like temperature, server load, distance). Can be empty.\n- `:event_type` - (optional) type of the underlying Event, if empty a default type\n  `incident_updated` will be used\n- `:event_actors` - (optional) additional actors of the underlying Event. If empty no actors are\n  defined.\n- `:event_params` - (optional) additional parameters of the Event. If empty no params are\n  defined.\n- `:event_origin_messages` - (optional) list of references to raw messages linked with the\n  underlying Event. If empty no raw messages are linked with the Event.","ref":"Runbox.Scenario.OutputAction.IncidentHistory.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.IncidentHistory.t/0","doc":"Incident history.\n\nNote Incident history is synonymous to Events and thus carries similar parameters.\n\n- `:status` - status of the Incident\n- `:severity` - severity of the Incident\n- `:timestamp` - time of the change\n- `:description` - description of the change - what has happened, will be used as Event template\n- `:attributes` - (optional) significant additional attributes that changed with the Incident\n  (usually metrics, like temperature, server load, distance). Can be empty.\n- `:event_type` - (optional) type of the underlying Event, if empty a default type\n  `incident_updated` will be used\n- `:event_actors` - (optional) additional actors of the underlying Event. If empty no actors are\n  defined.\n- `:event_params` - (optional) additional parameters of the Event. If empty no params are\n  defined.\n- `:event_origin_messages` - (optional) list of references to raw messages linked with the\n  underlying Event. If empty no raw messages are linked with the Event.","ref":"Runbox.Scenario.OutputAction.IncidentHistory.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.IncidentPatch","doc":"Parameters for output action Incident Patch.\n\nThe resulting output action updates an incident.","ref":"Runbox.Scenario.OutputAction.IncidentPatch.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.IncidentPatch.t/0","doc":"Incident Patch","ref":"Runbox.Scenario.OutputAction.IncidentPatch.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.Notification","doc":"Parameters for output action Notification.\n\nThe resulting output action sends a notification.","ref":"Runbox.Scenario.OutputAction.Notification.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.Notification.t/0","doc":"Notification\n\n  * `:type` - string, type of the notification\n  * `:data` - map, data for the template evaluation\n  * `:primary_asset` - string, optional, id of an asset that corresponds to this notification\n  * `:ids` - list of asset ids, optional, to filter recipients, each recipient must have\n    sufficient privileges to see all listed IDs\n  * `:aqls` - map, AQLs which are evaluated, provide further context to the templates, and also can\n    serve the same purpose as `ids` - filter recipients to only those who can see the whole\n    result of the query. Key is the name of the AQL which can be used in the template. Value\n    is a map with `aql` (the AQL query) and `primary` (whether the AQL should also be used\n    to filter recipients) keys.\n  * `:priority` - optional, defaults to `:medium`, can be `:low`, `:medium`, `:high`, only\n    applicable to some channels\n  * `:metadata` - map, optional, additional metadata which can be used in notification group\n    subscriptions. Should adhere to the format specified in `Runbox.Scenario.Manifest.notifications`.\n  * `:direct_subscriptions` - list of maps, subscriptions to be used additionally to the usual\n    routing. Each map should have the following.\n      * `:user` - map, user object to be used instead of Altworx object, should have\n        `notification.email` and optionally even `notification.language`.\n      * `:templates` - list of ids, which templates should be used\n      * `:channels` - list of ids, which channels should be used\n  * `:attachments` - list of maps, optional, attachments that should be sent with the notification.\n    Each map has the following keys.\n      * `:data` - binary, content of the attachment\n      * `:filename` - string, name of the file\n      * `:content_type` - string, optional, MIME type of the data\n      * `:type` - whether the attachment is to inlined in the template (`:inline`) or not\n        (`:attachment`, this is the default)","ref":"Runbox.Scenario.OutputAction.Notification.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.UpsertAssetAttributes","doc":"Parameters for output action Upsert Asset Attributes.\n\nThe resulting output action will create or update attributes of the given\nasset.","ref":"Runbox.Scenario.OutputAction.UpsertAssetAttributes.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.UpsertAssetAttributes.t/0","doc":"Upsert Asset Attributes\n\n  * `:type` - asset type\n  * `:id` - asset ID\n  * `:attributes` - a map of attributes in format `%{\"name\" => value}` to be\n    inserted or updated","ref":"Runbox.Scenario.OutputAction.UpsertAssetAttributes.html#t:t/0"},{"type":"module","title":"Runbox.Scenario.OutputAction.UpsertEdge","doc":"Parameters for output action Upsert Edge.\n\nThe resulting output action will create an edge between two assets. The\nassets do not have to exist at the time of the edge creation.","ref":"Runbox.Scenario.OutputAction.UpsertEdge.html"},{"type":"type","title":"Runbox.Scenario.OutputAction.UpsertEdge.t/0","doc":"Upsert Edge\n\n  * `:from_type` - type of the asset which this edge goes out from\n  * `:from_id` - id of the asset which this edge goes out from\n  * `:to_type` - type of the asset which this edge goes to\n  * `:to_id` - id of the asset which this edge goes to\n  * `:type` - type of the edge","ref":"Runbox.Scenario.OutputAction.UpsertEdge.html#t:t/0"},{"type":"module","title":"Runbox.Runtime.Stage.Sandbox","doc":"Sandbox is helper for executing runs without started Altworx application.\n\nSandbox can be used for scenarios unit testing and also for interactive\ndevelopment of scenarios. When used for unit testing, it can be used\ndirectly or via `Runbox.Runtime.Stage.Sandbox.TestRunner`.\n\nFor interactive development of scenarios, run `iex --erl \"-runbox mode slave\" -S mix`\nfrom command line in your scenarios application root directory and then use Sandbox\nfunctions to execute your runs (of course use `recompile` before run execution if you\nchanged scenario code).","ref":"Runbox.Runtime.Stage.Sandbox.html"},{"type":"function","title":"Runbox.Runtime.Stage.Sandbox.execute_run/3","doc":"Starts new run for `scenario_id` and waits until all input messages are processed.\n\nReturns all output actions generated by run execution. Input messages for each runtime\ntopic used by scenario should be defined in `topics` argument. Undefined topics are\nconsidered empty. Messages in each topic must be in ascending order by `timestamp`.\n\nThere are few options that can be specified.\n\n- `:start_from` - specify the start from value for the run. The value is used to filter out\n  messages (as in a real run, input topics only use messages with `timestamp >= start_from`) and\n  the value is provided to template's `init` callback.\n- `:modules` - list of modules containing scenarios (manifests, templates). If list of modules is\n  specified `execute_run` does not search scenario in `:scenarios` application release, but in\n  given modules. It opens possibility to write ad-hoc scenarios with only dependency on Runbox\n  application, for example use it in [Livebook](https://livebook.dev/). To see example of such\n  livebook just run `livebook server --home .` in runbox root directory, go to generated livebook\n  server link in browser and finally open `sandbox-scenario-demo.livemd` document. Running docker\n  or altworx is not needed, only runbox app (and its deps) is required!","ref":"Runbox.Runtime.Stage.Sandbox.html#execute_run/3"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.topic_name/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.html#t:topic_name/0"},{"type":"type","title":"Runbox.Runtime.Stage.Sandbox.topics/0","doc":"","ref":"Runbox.Runtime.Stage.Sandbox.html#t:topics/0"},{"type":"module","title":"Runbox.Runtime.Stage.Sandbox.TestRunner","doc":"For new unit testing of scenarios it is recommended to use functions in\n`Runbox.Runtime.Stage.Sandbox` directly. This module should only help to\nconvert old scenarios integration tests (using Solutions.TestRunner) to unit\ntests. For examples of such conversion see tests in the scenarios master\nbranch.","ref":"Runbox.Runtime.Stage.Sandbox.TestRunner.html"},{"type":"function","title":"Runbox.Runtime.Stage.Sandbox.TestRunner.run_test/1","doc":"Runs an unit test according to the `test_def` definition.\n\nFunction accepts the same `test_def` definition as `Solutions.TestRunner.run_test/1`\nwith few differences:\n\n  * Only `run_options.scenario_id`, `run_options.start_from`, `messages` and `expected_actions`\n    properties are used, other properties are ignored.\n\n  * Instead of output log format `expected_actions` are `Runbox.Scenario.OutputAction`\n    structures, for example\n\n    ```\n    %{\n      action: :add_asset,\n      params: %{attributes: %{}, id: \"/diamonds/O\"},\n      result: \"nil\",\n      serialization_vector: [\"/diamonds/O\"],\n      side_effects: false,\n      timestamp: 1\n    }\n    ```\n\n    must be changed to:\n\n    ```\n    %Runbox.Scenario.OutputAction{\n      body: %Runbox.Scenario.OutputAction.UpsertAssetAttributes{\n        type: \"/diamonds\",\n        id: \"O\", attributes: %{}\n      },\n      timestamp: 1\n    }\n    ```\n\nTo see differences take a look at `deduplication_diamond_test.exs` in scenarios and\nthe same test in solutions.","ref":"Runbox.Runtime.Stage.Sandbox.TestRunner.html#run_test/1"},{"type":"module","title":"Runbox.Notifications.TemplateHelper","doc":"Set of utility functions for use in notification templates.","ref":"Runbox.Notifications.TemplateHelper.html"},{"type":"function","title":"Runbox.Notifications.TemplateHelper.asset_link/2","doc":"Returns a URL to the asset detail.\n\nThe type of UI can be specified, and the link is generated to work with that UI. Can be `:new` or\n`:old`.","ref":"Runbox.Notifications.TemplateHelper.html#asset_link/2"},{"type":"function","title":"Runbox.Notifications.TemplateHelper.format_number/2","doc":"Formats a number by separating thousands with a separator.","ref":"Runbox.Notifications.TemplateHelper.html#format_number/2"},{"type":"function","title":"Runbox.Notifications.TemplateHelper.format_ts/3","doc":"Formats timestamp into the given format in the given timezone.","ref":"Runbox.Notifications.TemplateHelper.html#format_ts/3"},{"type":"macro","title":"Runbox.Notifications.TemplateHelper.include_template/4","doc":"Wraps the given EEx content with a EEx template.\n\nTemplates can be bundled with a scenario or be a part of the system, `source`\nshould be set to `scenario_name` for scenario-based\ntemplates and `:system` for templates bundled with the system.\n\nThe templates that can be included, so called shared templates, are stored in\n`shared` folder\n(`scenarios/priv/notifications/{scenario_name}/shared`).\nEach shared template consists of two files - header and footer - which are\nwrapped around the given content. The filenames have `_header` and `_footer`\nappended, for `template_name = \"email\"` the two filenames are\n`email_header.eex` and `email_footer.eex`. System templates are stored in\n`apps/asset_map/templates/shared`.\n\nVia `context` you can pass additional parameters to the shared template\n(passed as assigns). The expected context depends on the template.","ref":"Runbox.Notifications.TemplateHelper.html#include_template/4"},{"type":"macro","title":"Example usage - Runbox.Notifications.TemplateHelper.include_template/4","doc":"```\n<% alias Runbox.Notifications.TemplateHelper %>\n<% require TemplateHelper %>\n<%= TemplateHelper.include_template({\"test\", 1}, \"email_rich\", title: \"Test email\") do %>\n   Test Email \n   This text is surrounded by the template... \n<% end %>\n```","ref":"Runbox.Notifications.TemplateHelper.html#include_template/4-example-usage"},{"type":"function","title":"Runbox.Notifications.TemplateHelper.ui_url/0","doc":"Returns the UI url.","ref":"Runbox.Notifications.TemplateHelper.html#ui_url/0"},{"type":"module","title":"Runbox.Scenario.Asset","doc":"Utilities for working with Asset","ref":"Runbox.Scenario.Asset.html"},{"type":"function","title":"Runbox.Scenario.Asset.split_id/1","doc":"Split asset id by the last slash.","ref":"Runbox.Scenario.Asset.html#split_id/1"},{"type":"function","title":"Example - Runbox.Scenario.Asset.split_id/1","doc":"iex> Asset.split_id(\"/type/id\")\n    {\"/type\", \"id\"}\n    iex> Asset.split_id(\"id\")\n    {\"\", \"id\"}","ref":"Runbox.Scenario.Asset.html#split_id/1-example"},{"type":"module","title":"Runbox.Utils.Enum","doc":"A set of utility functions for Enums.","ref":"Runbox.Utils.Enum.html"},{"type":"function","title":"Runbox.Utils.Enum.each_while_ok/2","doc":"Returns `:ok` if `fun` applied to every element of `enumerable` returns `:ok`.\nOtherwise it returns the first error occurred during `fun` call.","ref":"Runbox.Utils.Enum.html#each_while_ok/2"},{"type":"function","title":"Example - Runbox.Utils.Enum.each_while_ok/2","doc":"iex> each_while_ok([], fn _ -> :not_called_at_all end)\n    :ok\n\n    iex> each_while_ok([1, 2, 3], fn _ -> :ok end)\n    :ok\n\n    iex> each_while_ok([1, 2, 3], &(if &1 == 2, do: {:error, &1}, else: :ok))\n    {:error, 2}","ref":"Runbox.Utils.Enum.html#each_while_ok/2-example"},{"type":"function","title":"Runbox.Utils.Enum.map_while_ok/2","doc":"Returns `{:ok, list_of_values}` if `fun` applied to every element of\n`enumerable` returns `{:ok, value}`. Otherwise it returns the first\nerror occurred during `fun` call.","ref":"Runbox.Utils.Enum.html#map_while_ok/2"},{"type":"function","title":"Example - Runbox.Utils.Enum.map_while_ok/2","doc":"iex> map_while_ok([], fn _ -> :not_called_at_all end)\n    {:ok, []}\n\n    iex> map_while_ok([1, 2, 3], &({:ok, &1 * 2}))\n    {:ok, [2, 4, 6]}\n\n    iex> map_while_ok([1, 2, 3], &(if &1 == 2, do: {:error, &1 * 2}, else: {:ok, &1 * 2}))\n    {:error, 4}","ref":"Runbox.Utils.Enum.html#map_while_ok/2-example"},{"type":"function","title":"Runbox.Utils.Enum.reduce_while_ok/3","doc":"Invokes `fun` for each element in the `enumerable` with the accumulator.\nIf every `fun` call returns `{:ok, new_acc}`, functions returns `{:ok, last_acc}`.\nOtherwise it returns the first error occurred during `fun` call.","ref":"Runbox.Utils.Enum.html#reduce_while_ok/3"},{"type":"function","title":"Example - Runbox.Utils.Enum.reduce_while_ok/3","doc":"iex> reduce_while_ok([], :initial, fn _, _ -> :not_called_at_all end)\n    {:ok, :initial}\n\n    iex> reduce_while_ok([1, 2, 3], 0, &({:ok, &1 + &2}))\n    {:ok, 6}\n\n    iex> reduce_while_ok([1, 2, 3], 0, &(if &1 == 2, do: {:error, &1 + &2}, else: {:ok, &1 + &2}))\n    {:error, 3}","ref":"Runbox.Utils.Enum.html#reduce_while_ok/3-example"},{"type":"module","title":"Runbox.Utils.Map","doc":"A set of utility functions for Maps.","ref":"Runbox.Utils.Map.html"},{"type":"function","title":"Runbox.Utils.Map.get_path/3","doc":"Follows the `path` in the (deep) map, defaulting to `default` if some of the\nobjects on the path is missing.","ref":"Runbox.Utils.Map.html#get_path/3"},{"type":"function","title":"Example - Runbox.Utils.Map.get_path/3","doc":"iex> object = %{\"some\" => %{\"deep\" => %{\"object\" => \"data\"}}}\n    ...> Runbox.Utils.Map.get_path(object, [\"some\", \"deep\", \"object\"])\n    \"data\"\n    iex> Runbox.Utils.Map.get_path(object, [\"non-existent\"], \"default\")\n    \"default\"","ref":"Runbox.Utils.Map.html#get_path/3-example"},{"type":"module","title":"Runbox.Utils.Path","doc":"Utilities for handling configured paths.","ref":"Runbox.Utils.Path.html"},{"type":"function","title":"Runbox.Utils.Path.altworx_root_env_var/0","doc":"","ref":"Runbox.Utils.Path.html#altworx_root_env_var/0"},{"type":"function","title":"Runbox.Utils.Path.get_altworx_root/0","doc":"Gets the Altworx root dir.","ref":"Runbox.Utils.Path.html#get_altworx_root/0"},{"type":"function","title":"Runbox.Utils.Path.resolve_path/1","doc":"Resolves a possibly relative path to absolute path by prepending the Altworx\nroot dir (see `set_altworx_root/1`).","ref":"Runbox.Utils.Path.html#resolve_path/1"},{"type":"function","title":"Examples - Runbox.Utils.Path.resolve_path/1","doc":"iex> Path.set_altworx_root(\"/opt/altworx\")\n    :ok\n    iex> Path.resolve_path(\"/already/absolute/path\")\n    \"/already/absolute/path\"\n    iex> Path.resolve_path(\"some/../relative/path\")\n    \"/opt/altworx/relative/path\"","ref":"Runbox.Utils.Path.html#resolve_path/1-examples"},{"type":"function","title":"Runbox.Utils.Path.set_altworx_root/1","doc":"Sets where the Altworx root dir is. Configuration and data dirs are supposed\nto be relative to the root dir. It is typically the directory which the VM is\nstarted in.","ref":"Runbox.Utils.Path.html#set_altworx_root/1"},{"type":"extras","title":"Altworx Runbox","doc":"# Altworx Runbox\n\n**Runbox** is a runtime environment for Altworx scenarios.\nIt provides essential data structures, APIs, and tools for developing, testing, and packaging scenarios.\n\nCheck out also [Toolbox](https://hex.pm/packages/altworx_toolbox), which builds on top of Runbox and\nprovides conveniences and additional abstractions for writing scenarios.\n\nNote that there are two types of documentation for Runbox.\nThe [main documentation](https://hexdocs.pm/altworx_runbox) (the one you are probably seeing now)\ncovers all user-facing modules. This is the go-to documentation when writing scenarios.\nHowever, there is also the [internal documentation](https://hexdocs.pm/altworx_runbox/internal)\nthat covers also internal modules. That documentation might be useful if you want to dig deeper\ninto how scenarios run.","ref":"readme.html"},{"type":"extras","title":"Scenario projects - Altworx Runbox","doc":"Scenarios in Altworx are developed as Elixir/Mix projects, with a single project potentially containing\nmultiple scenarios. When packaged, all scenarios in a project are bundled together.\n\nTo start a new scenario project, create a blank project using `mix new project_name`, then add Runbox\nas a dependency in your `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    {:runbox, \"~> 9.0\", hex: :altworx_runbox}\n  ]\nend\n```\n\nNote that currently there is a limitation that scenario module names must start with the `Scenario.`\nprefix, although the project or app itself can have any name.","ref":"readme.html#scenario-projects"},{"type":"extras","title":"Configuration - Altworx Runbox","doc":"Runbox requires the `:scenario_config_dir` environment variable under the :runbox app to be set.\nThis is automatically handled when running in Altworx but may need to be configured for the `test`\nenvironment. You can use a dummy value for testing, like so in `config/test.exs`:\n\n```elixir\nimport Config\n\nconfig :runbox, scenario_config_dir: \"/non-existing/does/not/matter\"\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Building scenario artefacts - Altworx Runbox","doc":"Using Runbox, scenarios are packaged into *artefacts* (also called *releases*) that can be deployed\nto and run in Altworx. These artefacts include both the scenarios code and the runtime environment.\nTo build a scenario artefact, make sure you have Docker installed and then run\n\n```sh\nmix altworx.scenario_release\n```\n\nYou can then load the built scenario artifact in the Admin UI. Do not forget to restart Altworx\nafterwards.","ref":"readme.html#building-scenario-artefacts"},{"type":"extras","title":"Architectural details - Altworx Runbox","doc":"Altworx runs in a single BEAM node and spawns a separate BEAM node for each scenario release.\nBoth Altworx and the scenario nodes run the Runbox app, so Runbox also serves for communication\nbetween these two. On the Altworx node, it is responsible for starting the scenario nodes.\n\nScenario nodes can are used for:\n* listing scenarios in a scenario release\n* spawning components for a scenario \"run\"\n* processing notification templates","ref":"readme.html#architectural-details"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"Master - Changelog","doc":"","ref":"changelog.html#master"},{"type":"extras","title":"Changes - Changelog","doc":"","ref":"changelog.html#changes"},{"type":"extras","title":"10.0.0 - Changelog","doc":"","ref":"changelog.html#10-0-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Update the Livebook example\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/30))\n- Require unit ID to be explicitly set when creating the Unit struct\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/31),\n   [#6609](https://altworx.plan.io/issues/6609))\n- Improve the documentation\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/34),\n   [#6195](https://altworx.plan.io/issues/6195))\n- Use peer instead of deprecated slave module for scenario's nodes\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/33),\n   [#5918](https://altworx.plan.io/issues/5918))","ref":"changelog.html#changes"},{"type":"extras","title":"9.0.0 - Changelog","doc":"","ref":"changelog.html#9-0-0"},{"type":"extras","title":"Warnings - Changelog","doc":"- Notifications specifications are no longer retrieved from `spec.exs` file but\n  are now part of Manifest, all scenarios should now define their notifications\n  specifications directly in scenario manifest.","ref":"changelog.html#warnings"},{"type":"extras","title":"Changes - Changelog","doc":"- Improve docs for `Runbox.Scenario.OutputAction.Event`\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/26))\n- Move notification specification to scenario manifest\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/28),\n   [#6569](https://altworx.plan.io/issues/6569))\n- Better separate scenario runtimes\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/29),\n   [#6665](https://altworx.plan.io/issues/6665))","ref":"changelog.html#changes"},{"type":"extras","title":"8.0.0 - Changelog","doc":"","ref":"changelog.html#8-0-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Add additional event parameters to Incident History OA\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/27),\n   [#6592](https://altworx.plan.io/issues/6592))","ref":"changelog.html#changes"},{"type":"extras","title":"7.0.1 - Changelog","doc":"","ref":"changelog.html#7-0-1"},{"type":"extras","title":"Changes - Changelog","doc":"- Anticipate errors from scenario manifest\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/23),\n   [#6312](https://altworx.plan.io/issues/6312))\n- Explicitly propagate altworx root dir to slave\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/24),\n   [#6331](https://altworx.plan.io/issues/6331))","ref":"changelog.html#changes"},{"type":"extras","title":"7.0.0 - Changelog","doc":"","ref":"changelog.html#7-0-0"},{"type":"extras","title":"Warnings - Changelog","doc":"- Scenarios are now built with Elixir 1.15.7 and OTP 26.2.1. There may be some breaking\n  changes for your code (see https://hexdocs.pm/elixir/1.15/changelog.html and\n  https://www.erlang.org/downloads/26). It is recommended to update your `.tool-versions`\n  to match these versions.","ref":"changelog.html#warnings"},{"type":"extras","title":"Changes - Changelog","doc":"- Forbid slashes in IDs contained in asset/incident creation OAs\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/22),\n   [#6327](https://altworx.plan.io/issues/6327))\n- Build scenarios with Elixir 1.15 and OTP 26 (to be compatible with Altworx 24.3)\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/21),\n   [#6285](https://altworx.plan.io/issues/6285))","ref":"changelog.html#changes"},{"type":"extras","title":"6.0.0 - Changelog","doc":"","ref":"changelog.html#6-0-0"},{"type":"extras","title":"Breaking Changes - Changelog","doc":"- All output actions have changed. The following snippet shows how should be\n  the output actions updated from the old format to the new one.\n  ```elixir\n  alias Runbox.Scenario.OutputAction, as: OA\n\n  # Create Asset\n  # old\n  OA.new_create_asset_action(\"/asset/camera/1\", 1, %{\"a\" => 1})\n  # new\n  %OA.UpsertAssetAttributes{type: \"/asset/camera\", id: \"1\", attributes: %{\"a\" => 1}}\n\n  # Update Asset\n  # old - deletes and updates attributes via a single action\n  OA.new_update_asset_action(\"/asset/camera/1\", 1, %{\"a\" => 1}, %{\"b\" => true})\n  # new - one action for delete, another one for upsert\n  %OA.DeleteAssetAttributes{type: \"/asset/camera\", id: \"1\", attributes: %{\"b\" => true}}\n  %OA.UpsertAssetAttributes{type: \"/asset/camera\", id: \"1\", attributes: %{\"a\" => 1}}\n\n  # Upsert Asset\n  # old\n  OA.new_upsert_asset_action(\"/asset/camera/1\", 1, %{\"a\" => 1})\n  # new\n  %OA.UpsertAssetAttributes{type: \"/asset/camera\", id: \"1\", attributes: %{\"a\" => 1}}\n\n  # Delete Asset\n  # old\n  OA.new_delete_asset_action(\"/asset/camera/1\", 1)\n  # new\n  %OA.DeleteAllAssetAttributes{type: \"/asset/camera\", id: \"1\"}\n\n  # Create Edge\n  # old\n  OA.new_create_edge_action(1, \"/asset/camera/1\", \"/asset/room/A\", \"observes\")\n  # new\n  %OA.UpsertEdge{\n    from_type: \"/asset/camera\",\n    from_id: \"1\",\n    to_type: \"/asset/room\",\n    to_id: \"A\",\n    type: \"observes\"\n  }\n\n  # Upsert Edge\n  # old\n  OA.new_upsert_edge_action(1, \"/asset/camera/1\", \"/asset/room/A\", \"observes\")\n  # new\n  %OA.UpsertEdge{\n    from_type: \"/asset/camera\",\n    from_id: \"1\",\n    to_type: \"/asset/room\",\n    to_id: \"A\",\n    type: \"observes\"\n  }\n\n  # Delete Edge\n  # old\n  OA.new_delete_edge_action(1, \"/asset/camera/1\", \"/asset/room/A\", \"observes\")\n  # new\n  %OA.DeleteEdge{\n    from_type: \"/asset/camera\",\n    from_id: \"1\",\n    to_type: \"/asset/room\",\n    to_id: \"A\",\n    type: \"observes\"\n  }\n\n  # Notification\n  # old\n  OA.new_notification_action(1, %{type: \"created_incident\", data: %{\"a\" => 1}})\n  # new\n  %OA.Notification{type: \"created_incident\", data: %{\"a\" => 1}}\n\n  # Event\n  # old\n  OA.new_event_action(1, %{\n    type: \"event_type\",\n    template: \"${actors.wagon}\",\n    actors: %{\"wagon\" => %{asset_type: \"/assets/wagon\", asset_id: \"123\"}}\n  })\n  # new\n  %OA.Event{\n    type: \"event_type\",\n    template: \"${actors.wagon}\",\n    actors: %{\"wagon\" => %{asset_type: \"/assets/wagon\", asset_id: \"123\"}}\n  }\n\n  # Execute SQL\n  # old\n  OA.execute_sql_action(1, %{\n    db_connection: db_connection,\n    sql_query: \"SELECT 1\",\n    data: [],\n    type: :postgresql\n  })\n  # new\n  %OA.ExecuteSQL{\n    db_connection: db_connection,\n    sql_query: \"SELECT 1\",\n    data: [],\n    type: :postgresql\n  }\n\n  # Create Incident\n  # old\n  OA.new_create_incident_action(1, %OA.Incident{\n    type: \"type\",\n    id: \"id\",\n    subject: \"subject\",\n    status: \"status\",\n    resolved: false,\n    severity: 1,\n    future: [],\n    history: [%OA.IncidentHistory{\n      status: \"status\",\n      severity: 1,\n      timestamp: 1,\n      description: \"description\"\n    }]\n  })\n  # new\n  %OA.Incident{\n    type: \"type\",\n    id: \"id\",\n    subject: \"subject\",\n    status: \"status\",\n    resolved: false,\n    severity: 1,\n    future: [],\n    history: [%OA.IncidentHistory{\n      status: \"status\",\n      severity: 1,\n      timestamp: 1,\n      description: \"description\"\n    }]\n  }\n\n  # Update Incident\n  # old\n  OA.new_update_incident_action(1, %OA.IncidentPatch{\n    type: \"type,\n    id: \"id\",\n    severity: 2\n  })\n  # new\n  %OA.IncidentPatch{\n    type: \"type,\n    id: \"id\",\n    severity: 2\n  }\n  ```\n\n  Refer to the documentation in `Runbox.Scenario.OutputAction` for details.\n\n  There is also a helper `Runbox.Scenario.Asset.split_id/1`. It splits the full\n  asset ID to asset type and asset ID.\n\n- The sandbox tests have changed the format of the produced output action.\n  Previously it was a struct\n\n  ```elixir\n  %Runbox.Scenario.OutputAction{\n    type: type,\n    timestamp: ts,\n    body: body\n  }\n  ```\n\n  Now the `:type` is gone and `:body` always contains a struct with the output\n  action parameters, e.g.\n\n  ```elixir\n  %Runbox.Scenario.OutputAction{\n    timestamp: ts,\n    body: %Runbox.Scenario.OutputAction.UpsertAssetAttributes{type: type, id: id, attributes: attrs}\n  }\n  ```","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Changes - Changelog","doc":"- New output actions for asset and edge.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/19),\n   [#6129](https://altworx.plan.io/issues/6129))\n- Rework of output action creation and handling.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/20),\n   [#6177](https://altworx.plan.io/issues/6177))","ref":"changelog.html#changes"},{"type":"extras","title":"5.0.0 - Changelog","doc":"","ref":"changelog.html#5-0-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Remove deprecation for '/incident' type.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/18),\n   [#5999](https://altworx.plan.io/issues/6066))","ref":"changelog.html#changes"},{"type":"extras","title":"Breaking changes - Changelog","doc":"- Removed code which separated \"/incident\" prefix from params's type","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"4.0.0 - Changelog","doc":"","ref":"changelog.html#4-0-0"},{"type":"extras","title":"Changes - Changelog","doc":"- New output actions for incidents. Also remove/update obsolete code.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/17),\n   [#5999](https://altworx.plan.io/issues/5999))","ref":"changelog.html#changes"},{"type":"extras","title":"Breaking changes - Changelog","doc":"- Removed code, which is likely not used anywhere, but check the scenarios.\n  - `Runbox.Scenario.OutputAction.new_incident_action/2`\n  - `%Runbox.Scenario.OutputAction.Incident{}`\n  - `%Runbox.Scenario.OutputAction.IncidentState{}`\n\n- New output actions of types `:create_incident` and `:update_incident`.\n  Altworx has to know how to handle those when depending on this version.","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"3.0.0 - Changelog","doc":"","ref":"changelog.html#3-0-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Move certain modules from Toolbox to Runbox\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/16),\n   [#5848](https://altworx.plan.io/issues/5848))","ref":"changelog.html#changes"},{"type":"extras","title":"Breaking changes - Changelog","doc":"- Many modules were moved from Toolbox to Runbox (some kept their name, but the majority\n  of them was also renamed to be under the Runbox \"namespace\"), here are the ones that\n  affect scenario authors (for a complete list, see the task):\n  - Modules that will require changes in aliases (just replace `Toolbox` with `Runbox`)\n    - `Toolbox.Notifications.TemplateHelper` → `Runbox.Notifications.TemplateHelper`\n    - `Toolbox.Runtime.RuntimeInstruction` → `Runbox.Runtime.RuntimeInstruction`\n    - `Toolbox.Utils.Path` → `Runbox.Utils.Path`\n    - `Toolbox.Scenario.Config` → `Runbox.Scenario.Config`\n    - `Toolbox.Scenario.Helper` → `Runbox.Scenario.Helper`\n    - `Toolbox.Scenario.Manifest` → `Runbox.Scenario.Manifest`\n  - A module that requires change of `@behaviour` (just replace `Toolbox` with `Runbox`)\n    - `Toolbox.Scenario.Template.StageBased`→ `Runbox.Scenario.Template.StageBased`\n  - Configuration key move\n    - `:scenario_config_dir` config key was moved from `:toolbox` to `:runbox`,\n      you may have to change this in your `config/test.exs`","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"2.1.0 - Changelog","doc":"","ref":"changelog.html#2-1-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Remove runbox version check\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/15),\n   [#5828](https://altworx.plan.io/issues/5828))","ref":"changelog.html#changes"},{"type":"extras","title":"2.0.0 - Changelog","doc":"","ref":"changelog.html#2-0-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Build scenarios with Elixir 1.14 and OTP 25 (to be compatible with Altworx 23.3+)\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/14),\n   [#5799](https://altworx.plan.io/issues/5907))","ref":"changelog.html#changes"},{"type":"extras","title":"1.4.1 - Changelog","doc":"","ref":"changelog.html#1-4-1"},{"type":"extras","title":"Changes - Changelog","doc":"- Bump toolbox dependency to 2.0.0","ref":"changelog.html#changes"},{"type":"extras","title":"1.4.0 - Changelog","doc":"","ref":"changelog.html#1-4-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Start slave VM as a hidden node\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/11),\n   [#5799](https://altworx.plan.io/issues/5799))\n- Check that scenario timeouts are not registered to the past.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/10),\n   [#5827](https://altworx.plan.io/issues/5827))\n- Use timeout message timestamp to register scenario timeouts.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/10),\n   [#5827](https://altworx.plan.io/issues/5827))\n- Check input messages order prior sandbox run execution.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/10),\n   [#5827](https://altworx.plan.io/issues/5827))","ref":"changelog.html#changes"},{"type":"extras","title":"Breaking changes - Changelog","doc":"- API function to register timeouts `Toolbox.Runtime.RuntimeInstruction.register_timeout/2`\n  was removed, update scenarios to use `Toolbox.Runtime.RuntimeInstruction.register_timeout/1`\n  instead.\n- Field `timeout` was removed from `Toolbox.Runtime.RuntimeInstruction.Timeout`","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"1.3.0 - Changelog","doc":"","ref":"changelog.html#1-3-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Remove `Runbox.Scenario.Template` and use only `Runbox.ScenarioTemplate`.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/9))","ref":"changelog.html#changes"},{"type":"extras","title":"1.2.0 - Changelog","doc":"","ref":"changelog.html#1-2-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Default mode is `:slave`. Scenario repositories do not need to set this\n  anymore. Altworx needs to set the `:master` mode explicitly.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/8),\n   [#5714](https://altworx.plan.io/issues/5714))\n- Find scenario modules for sandbox testing from the current mix app. Scenario\n  repositories do not need to set `:scenario_app` app env anymore even for\n  testing.\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/8),\n   [#5714](https://altworx.plan.io/issues/5714))","ref":"changelog.html#changes"},{"type":"extras","title":"1.1.0 - Changelog","doc":"","ref":"changelog.html#1-1-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Mix task for building scenario releases\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/5),\n   [#5713](https://altworx.plan.io/issues/5713))","ref":"changelog.html#changes"},{"type":"extras","title":"Additional info - Changelog","doc":"- There is no need to set `:runbox, scenario_app: :app_name` in the scenario app\n  anymore. New task `mix altworx.scenario_release` does it automatically.\n\n- There is no need to set `releases` key in the `project/1` of `mix.exs` in the\n  scenario app. In fact, the `release` key is ignored when using the new mix\n  task `mix altworx.scenario_release`.","ref":"changelog.html#additional-info"},{"type":"extras","title":"1.0.0 - Changelog","doc":"","ref":"changelog.html#1-0-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Relax runbox version check\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/7),\n   [#5817](https://altworx.plan.io/issues/5817))","ref":"changelog.html#changes"},{"type":"extras","title":"0.1.3 - Changelog","doc":"","ref":"changelog.html#0-1-3"},{"type":"extras","title":"Changes - Changelog","doc":"- Add support for start_from in Sandbox\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/4),\n   [#5821](https://altworx.plan.io/issues/5821))\n- Explicitly load modules when checking if a function is exported\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/6)\n   [#5784](https://altworx.plan.io/issues/5784))\n- Run slaves in interactive mode\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/6)\n   [#5784](https://altworx.plan.io/issues/5784))","ref":"changelog.html#changes"},{"type":"extras","title":"0.1.2 - Changelog","doc":"- Bump toolbox dependency to 1.0.0","ref":"changelog.html#0-1-2"},{"type":"extras","title":"0.1.1 - Changelog","doc":"","ref":"changelog.html#0-1-1"},{"type":"extras","title":"Changes - Changelog","doc":"- Use runbox from hex in demo livebook\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/2))\n- Fix load topic in Sandbox\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/3))","ref":"changelog.html#changes"},{"type":"extras","title":"0.1.0 - Changelog","doc":"","ref":"changelog.html#0-1-0"},{"type":"extras","title":"Changes - Changelog","doc":"- Runbox is in separate repository\n  ([PR](https://gitlab.dev.altworx.com/erlang/product/runbox/-/merge_requests/1),\n   [PR](https://gitlab.dev.altworx.com/erlang/product/altworx/-/merge_requests/1853),\n   [#5711](https://altworx.plan.io/issues/5711))","ref":"changelog.html#changes"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]},"content_type":"text/markdown"}